'This class contains global functions
Public Class Common

    ' moves the bits of an integer (number) for (count) bits to the right.
    Public Shared Function URShift(ByVal number As Integer, ByVal count As Integer) As Integer
        If number >= 0 Then
            Return (number >> count)
        Else
            Return (number >> count) + (2 << Not count)
        End If
    End Function

    ' creates an integer out of a 4 byte array (buf) 
    ' Function in .NET could be BitConverter.ToInt32(buf), but because of the reverse order of bytes 
    ' this is faster
    Public Shared Function CreateIntegerFromBytes(ByVal buf() As Byte) As Integer
        Return (CInt(buf(0)) << 24) Or (CInt(buf(1)) << 16) Or (CInt(buf(2)) << 8) Or (CInt(buf(3)))
    End Function
End Class
