' Base Exception in the Mp3VB Project
Public Class Mp3VBException
    Inherits Exception

#Region " Private Variables / Properties "
    Private m_exception As Exception
    Public Overridable ReadOnly Property Exception() As Exception
        Get
            Return m_exception
        End Get
    End Property
#End Region

#Region " Constructors "
    Public Sub New()

    End Sub
    Public Sub New(ByVal msg As String)
        MyBase.New(msg)
    End Sub
    Public Sub New(ByVal msg As String, ByVal t As Exception)
        MyBase.New(msg)
        m_exception = t
    End Sub
#End Region

End Class

' Exception in the BitStream
Public Class BitStreamException
    Inherits Mp3VBException

#Region " Private Variables / Properties "
    Private m_errorcode As Integer
    Public Overridable ReadOnly Property ErrorCode() As Integer
        Get
            Return m_errorcode
        End Get
    End Property
#End Region

#Region " Constructors "
    Public Sub New(ByVal msg As String, ByVal t As Exception)
        MyBase.New(msg, t)
        InitBlock()
    End Sub

    Public Sub New(ByVal errorcode As Integer, ByVal t As Exception)
        MyClass.New(getErrorString(errorcode), t)
        InitBlock()
        Me.m_errorcode = errorcode
    End Sub
    Private Sub InitBlock()
        m_errorcode = BitstreamErrors.UNKNOWN_ERROR
    End Sub
#End Region

#Region " Functions "
    Public Shared Function getErrorString(ByVal errorcode As Integer) As String
        Return "BitStream errorcode " + Convert.ToString(errorcode, 16)
    End Function
#End Region

End Class

Public Class LayerErrors

#Region " Shared Constants "
    Public Shared BITSTREAM_ERROR As Integer = &H100
    Public Shared DECODER_ERROR As Integer = &H200
#End Region

End Class

Public Class BitstreamErrors

#Region " Shared Variables / Constants "
    Public Shared UNKNOWN_ERROR As Integer
    Public Shared UNKNOWN_SAMPLE_RATE As Integer
    Public Shared STREAM_ERROR As Integer
    Public Shared UNEXPECTED_EOF As Integer
    Public Shared STREAM_EOF As Integer
    Public Shared BITSTREAM_LAST As Integer = &H1FF
#End Region

#Region " Shared Constructor "
    Shared Sub New()
        UNKNOWN_ERROR = LayerErrors.BITSTREAM_ERROR + 0
        UNKNOWN_SAMPLE_RATE = LayerErrors.BITSTREAM_ERROR + 1
        STREAM_ERROR = LayerErrors.BITSTREAM_ERROR + 2
        UNEXPECTED_EOF = LayerErrors.BITSTREAM_ERROR + 3
        STREAM_EOF = LayerErrors.BITSTREAM_ERROR + 4
    End Sub
#End Region

End Class

