' Class Implementing Layer 3 Decoder.

' date          programmers         comment                               
' 02/19/99      E.B                 Java Conversion
' 18/06/01      Michael Scheerer    Fixed bugs which causes negative indexes in method huffmann_decode 
'                                   and in method dequanisize_sample.                                     
' 16/07/01      Michael Scheerer    Catched a bug in method huffmann_decode, which causes an 
'                                   outOfIndexException. Cause : Indexnumber of 24 at SfBandIndex, which 
'                                   has only a length of 22. I have simply and dirty fixed the index 
'                                   to <= 22, because I'm not really be able to fix the bug. The 
'                                   Indexnumber is taken from the MP3 file and the origin Ma-Player 
'                                   with the same code works

Public Class Layer3Decoder

#Region " Private Variables "
    Private m_scalefac_buffer(53) As Integer

    Private m_is_1d(579) As Integer
    Private m_out_1d(575) As Single     ' (576 Frequency Lines)

    Private m_ro()()() As Single
    Private m_lr()()() As Single
    Private m_prevblck()() As Single
    Private m_k()() As Single
    Private m_nonzero(1) As Integer
    Private m_which_channels As OutputChannelsEnum
    Private m_max_gr As Integer
    Private m_frame_start As Integer
    Private m_part2_start As Integer
    Private m_channels As Integer
    Private m_first_channel As Integer
    Private m_last_channel As Integer
    Private m_sfreq As Integer

    Private m_reorder_table(8)() As Integer
    Private m_t_43(8191) As Single

    Private m_tsOutCopy(17) As Single
    Private m_rawout(35) As Single
    Private m_is_pos(575) As Integer    ' (576 Frequency Lines)
    Private m_is_ratio(575) As Single   ' (576 Frequency Lines)

    Private m_new_slen(3) As Integer
    Private m_samples1(31) As Single    ' (32 Subbands)
    Private m_samples2(31) As Single    ' (32 Subbands)

    Private m_sfBandIndex(8) As L3Table
    Private m_stream As Bitstream
    Private m_header As FrameHeader
    Private m_SynthFilter1, m_SynthFilter2 As SynthesisFilter
    Private m_AudBuffer As AudioOutputBuffer
    Private m_BitReserve As BitReserve
    Private m_SideInfo As SideInfo
    Private m_scalefac3(1) As Temp2Values
    Private m_scalefac() As Temp2Values

    Private m_Tabs As HuffcodeTableArray

#End Region

#Region " Constructor "
    Public Sub New(ByVal stream0 As Bitstream, ByVal header0 As FrameHeader, ByVal filtera As SynthesisFilter, ByVal filterb As SynthesisFilter, ByVal buffer0 As AudioOutputBuffer, ByVal which_ch0 As OutputChannelsEnum)
        m_Tabs = New HuffcodeTableArray

        m_ro = New Single()()() {New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}, New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}}
        m_lr = New Single()()() {New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}, New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}}
        m_prevblck = New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}
        m_k = New Single()() {New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}}

        m_scalefac3(0) = New Temp2Values
        m_scalefac3(1) = New Temp2Values
        m_scalefac = m_scalefac3

        ' L3Table init
        Dim l0() As Integer = {0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576}
        Dim s0() As Integer = {0, 4, 8, 12, 18, 24, 32, 42, 56, 74, 100, 132, 174, 192}
        Dim l1() As Integer = {0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 114, 136, 162, 194, 232, 278, 330, 394, 464, 540, 576}
        Dim s1() As Integer = {0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 136, 180, 192}
        Dim l2() As Integer = {0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576}
        Dim s2() As Integer = {0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192}

        Dim l3() As Integer = {0, 4, 8, 12, 16, 20, 24, 30, 36, 44, 52, 62, 74, 90, 110, 134, 162, 196, 238, 288, 342, 418, 576}
        Dim s3() As Integer = {0, 4, 8, 12, 16, 22, 30, 40, 52, 66, 84, 106, 136, 192}
        Dim l4() As Integer = {0, 4, 8, 12, 16, 20, 24, 30, 36, 42, 50, 60, 72, 88, 106, 128, 156, 190, 230, 276, 330, 384, 576}
        Dim s4() As Integer = {0, 4, 8, 12, 16, 22, 28, 38, 50, 64, 80, 100, 126, 192}
        Dim l5() As Integer = {0, 4, 8, 12, 16, 20, 24, 30, 36, 44, 54, 66, 82, 102, 126, 156, 194, 240, 296, 364, 448, 550, 576}
        Dim s5() As Integer = {0, 4, 8, 12, 16, 22, 30, 42, 58, 78, 104, 138, 180, 192}

        Dim l6() As Integer = {0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576}
        Dim s6() As Integer = {0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192}
        Dim l7() As Integer = {0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576}
        Dim s7() As Integer = {0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192}
        Dim l8() As Integer = {0, 12, 24, 36, 48, 60, 72, 88, 108, 132, 160, 192, 232, 280, 336, 400, 476, 566, 568, 570, 572, 574, 576}
        Dim s8() As Integer = {0, 8, 16, 24, 36, 52, 72, 96, 124, 160, 162, 164, 166, 192}

        m_sfBandIndex(0) = New L3Table(l0, s0)
        m_sfBandIndex(1) = New L3Table(l1, s1)
        m_sfBandIndex(2) = New L3Table(l2, s2)
        m_sfBandIndex(3) = New L3Table(l3, s3)
        m_sfBandIndex(4) = New L3Table(l4, s4)
        m_sfBandIndex(5) = New L3Table(l5, s5)
        m_sfBandIndex(6) = New L3Table(l6, s6)
        m_sfBandIndex(7) = New L3Table(l7, s7)
        m_sfBandIndex(8) = New L3Table(l8, s8)
        ' End of L3Table init

        For i As Integer = 0 To 8
            m_reorder_table(i) = Reorder(m_sfBandIndex(i).s)
        Next i

        m_stream = stream0
        m_header = header0
        m_SynthFilter1 = filtera
        m_SynthFilter2 = filterb
        m_AudBuffer = buffer0
        m_which_channels = which_ch0

        m_frame_start = 0
        If m_header.Mode() = FrameHeader.SINGLE_CHANNEL Then
            m_channels = 1
        Else
            m_channels = 2
        End If
        'If m_header.Version() = FrameHeader.MPEG1 Then
        m_max_gr = 2
        'Else
        '    m_max_gr = 1
        'End If

        'If m_header.Version() = FrameHeader.MPEG1 Then
        m_sfreq = m_header.SampleFrequency() + 3
        'ElseIf m_header.Version() = FrameHeader.MPEG25_LSF Then
        '    m_sfreq = m_header.SampleFrequency() + 6
        'Else
        '    m_sfreq = m_header.SampleFrequency()
        'End If

        If m_channels = 2 Then
            Select Case m_which_channels
                Case OutputChannelsEnum.LEFT_CHANNEL, OutputChannelsEnum.DOWNMIX_CHANNELS
                    m_last_channel = 0
                    m_first_channel = 0
                Case OutputChannelsEnum.RIGHT_CHANNEL
                    m_first_channel = 1
                    m_last_channel = 1
                    ' Case OutputChannelsEnum.BOTH_CHANNELS
                Case Else
                    m_first_channel = 0
                    m_last_channel = 1
            End Select
        Else
            m_first_channel = 0
            m_last_channel = 0
        End If

        m_nonzero(0) = 576
        m_nonzero(1) = 576

        m_BitReserve = New BitReserve
        m_SideInfo = New SideInfo


        Dim d43 As Double = (4.0 / 3.0)

        For i As Integer = 0 To 8191
            m_t_43(i) = System.Convert.ToSingle(Math.Pow(i, d43))
        Next

    End Sub
#End Region

#Region " Functions "

    ' Decode one frame, filling the buffer with the output samples.
    ' Subband samples are buffered and passed to the SynthesisFilter in one go.
    Public Sub DecodeFrame()

        Dim nSlots As Integer = m_header.Slots()
        Dim flush_main As Integer = 0
        Dim ss, sb As Integer
        Dim main_data_end As Integer = 0
        Dim bytes_to_discard As Integer = 0

        ' get the Side Informations
        ' the Side Informations contain:
        ' - how many bytes in previous frames are used for data in the active frame
        ' - regions and tables for hufman decoding
        GetSideInfo()

        For I As Integer = 0 To nSlots - 1
            m_BitReserve.PutBuf(m_stream.GetBits(8))
        Next


        main_data_end = Common.URShift(m_BitReserve.SSTell(), 3)

        flush_main = m_BitReserve.SSTell() And 7
        If flush_main <> 0 Then
            m_BitReserve.GetBits(8 - flush_main)
            main_data_end += 1
        End If

        bytes_to_discard = m_frame_start - main_data_end - m_SideInfo.main_data_begin

        m_frame_start += nSlots

        If bytes_to_discard < 0 Then
            Return
        End If
        If main_data_end > 4096 Then
            m_frame_start -= 4096
            m_BitReserve.RewindNBytes(4096)
        End If


        While bytes_to_discard > 0
            m_BitReserve.GetBits(8)
            bytes_to_discard -= 1
        End While


        For gr As Integer = 0 To m_max_gr - 1

            For ch As Integer = 0 To m_channels - 1

                m_part2_start = m_BitReserve.SSTell()

                GetScaleFactors(ch, gr)

                HuffmanDecode(ch, gr)
                DequantizeSample(m_ro(ch), ch, gr)
            Next ch

            Stereo(gr)

            If m_which_channels = OutputChannelsEnum.DOWNMIX_CHANNELS AndAlso m_channels > 1 Then
                DoDownmix()
            End If


            For ch As Integer = m_first_channel To m_last_channel

                Reorder(m_lr(ch), ch, gr)
                Antialias(ch, gr)
                Hybrid(ch, gr)

                For sb = 18 To 558 Step 36
                    For ss = 1 To 17 Step 2
                        m_out_1d((sb + ss)) = -m_out_1d((sb + ss))
                    Next
                Next


                If ch = 0 OrElse m_which_channels = OutputChannelsEnum.RIGHT_CHANNEL Then

                    For ss = 0 To 17
                        For sb = 0 To 31
                            m_samples1(sb) = m_out_1d((sb * 18 + ss))
                        Next
                        m_SynthFilter1.InputSamples(m_samples1)
                        m_SynthFilter1.CalculatePcmSamples(m_AudBuffer)
                    Next
                Else
                    For ss = 0 To 17
                        For sb = 0 To 31
                            m_samples2(sb) = m_out_1d((sb * 18 + ss))
                        Next
                        m_SynthFilter2.InputSamples(m_samples2)
                        m_SynthFilter2.CalculatePcmSamples(m_AudBuffer)
                    Next
                End If
            Next ch
        Next gr

        m_AudBuffer.WriteBuffer(1)

    End Sub

    ' Reads the side info from the stream, assuming the entire frame has been read already.
    ' Mono   : 136 bits (= 17 bytes)
    ' Stereo : 256 bits (= 32 bytes)
    Private Function GetSideInfo() As Boolean
        Dim ch, gr As Integer

        m_SideInfo.main_data_begin = m_stream.GetBits(9)
        If m_channels = 1 Then
            m_SideInfo.private_bits = m_stream.GetBits(5)
        Else
            m_SideInfo.private_bits = m_stream.GetBits(3)
        End If

        For ch = 0 To m_channels - 1
            m_SideInfo.ch(ch).scfsi(0) = m_stream.GetBits(1)
            m_SideInfo.ch(ch).scfsi(1) = m_stream.GetBits(1)
            m_SideInfo.ch(ch).scfsi(2) = m_stream.GetBits(1)
            m_SideInfo.ch(ch).scfsi(3) = m_stream.GetBits(1)
        Next

        For gr = 0 To 1

            For ch = 0 To m_channels - 1

                m_SideInfo.ch(ch).gr(gr).part2_3_length = m_stream.GetBits(12)
                m_SideInfo.ch(ch).gr(gr).big_values = m_stream.GetBits(9)
                m_SideInfo.ch(ch).gr(gr).global_gain = m_stream.GetBits(8)
                m_SideInfo.ch(ch).gr(gr).scalefac_compress = m_stream.GetBits(4)
                m_SideInfo.ch(ch).gr(gr).window_switching_flag = m_stream.GetBits(1)

                If m_SideInfo.ch(ch).gr(gr).window_switching_flag <> 0 Then
                    m_SideInfo.ch(ch).gr(gr).block_type = m_stream.GetBits(2)
                    m_SideInfo.ch(ch).gr(gr).mixed_block_flag = m_stream.GetBits(1)

                    m_SideInfo.ch(ch).gr(gr).table_select(0) = m_stream.GetBits(5)
                    m_SideInfo.ch(ch).gr(gr).table_select(1) = m_stream.GetBits(5)

                    m_SideInfo.ch(ch).gr(gr).subblock_gain(0) = m_stream.GetBits(3)
                    m_SideInfo.ch(ch).gr(gr).subblock_gain(1) = m_stream.GetBits(3)
                    m_SideInfo.ch(ch).gr(gr).subblock_gain(2) = m_stream.GetBits(3)

                    ' Set region_count parameters since they are implicit in this case.
                    If m_SideInfo.ch(ch).gr(gr).block_type = 0 Then
                        ' Side info bad: block_type is 0 in split block
                        Return False
                    ElseIf m_SideInfo.ch(ch).gr(gr).block_type = 2 AndAlso m_SideInfo.ch(ch).gr(gr).mixed_block_flag = 0 Then
                        m_SideInfo.ch(ch).gr(gr).region0_count = 8
                    Else
                        m_SideInfo.ch(ch).gr(gr).region0_count = 7
                    End If
                    m_SideInfo.ch(ch).gr(gr).region1_count = 20 - m_SideInfo.ch(ch).gr(gr).region0_count
                Else
                    m_SideInfo.ch(ch).gr(gr).table_select(0) = m_stream.GetBits(5)
                    m_SideInfo.ch(ch).gr(gr).table_select(1) = m_stream.GetBits(5)
                    m_SideInfo.ch(ch).gr(gr).table_select(2) = m_stream.GetBits(5)
                    m_SideInfo.ch(ch).gr(gr).region0_count = m_stream.GetBits(4)
                    m_SideInfo.ch(ch).gr(gr).region1_count = m_stream.GetBits(3)
                    m_SideInfo.ch(ch).gr(gr).block_type = 0
                End If
                m_SideInfo.ch(ch).gr(gr).preflag = m_stream.GetBits(1)
                m_SideInfo.ch(ch).gr(gr).scalefac_scale = m_stream.GetBits(1)
                m_SideInfo.ch(ch).gr(gr).count1table_select = m_stream.GetBits(1)
            Next
        Next

        Return True

    End Function

    Private Sub GetScaleFactors(ByVal ch As Integer, ByVal gr As Integer)
        Dim sfb, window As Integer
        Dim gr_info As GroupInfo = m_SideInfo.ch(ch).gr(gr)
        Dim scale_comp As Integer = gr_info.scalefac_compress
        Dim length0 As Integer = m_slen(0)(scale_comp)
        Dim length1 As Integer = m_slen(1)(scale_comp)

        If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 Then
            If gr_info.mixed_block_flag <> 0 Then
                ' mixed
                sfb = 0

                While sfb < 8
                    m_scalefac(ch).l(sfb) = m_BitReserve.GetBits(m_slen(0)(gr_info.scalefac_compress))
                    sfb += 1
                End While
                sfb = 3

                While sfb < 6
                    For window = 0 To 2
                        m_scalefac(ch).s(window)(sfb) = m_BitReserve.GetBits(m_slen(0)(gr_info.scalefac_compress))
                    Next window
                    sfb += 1
                End While
                sfb = 6

                While sfb < 12
                    window = 0

                    While window < 3
                        m_scalefac(ch).s(window)(sfb) = m_BitReserve.GetBits(m_slen(1)(gr_info.scalefac_compress))
                        window += 1
                    End While
                    sfb += 1
                End While

                sfb = 12
                window = 0

                While window < 3
                    m_scalefac(ch).s(window)(sfb) = 0
                    window += 1
                End While
            Else
                ' short
                For I As Integer = 0 To 5
                    For J As Integer = 0 To 2
                        m_scalefac(ch).s(J)(I) = m_BitReserve.GetBits(length0)
                    Next
                Next
                For I As Integer = 6 To 11
                    For J As Integer = 0 To 2
                        m_scalefac(ch).s(J)(I) = m_BitReserve.GetBits(length1)
                    Next
                Next

                m_scalefac(ch).s(0)(12) = 0
                m_scalefac(ch).s(1)(12) = 0
                m_scalefac(ch).s(2)(12) = 0
            End If
        Else
            ' long types 0, 1, 3
            If m_SideInfo.ch(ch).scfsi(0) = 0 OrElse gr = 0 Then
                m_scalefac(ch).l(0) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(1) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(2) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(3) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(4) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(5) = m_BitReserve.GetBits(length0)
            End If
            If m_SideInfo.ch(ch).scfsi(1) = 0 OrElse gr = 0 Then
                m_scalefac(ch).l(6) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(7) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(8) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(9) = m_BitReserve.GetBits(length0)
                m_scalefac(ch).l(10) = m_BitReserve.GetBits(length0)
            End If
            If m_SideInfo.ch(ch).scfsi(2) = 0 OrElse gr = 0 Then
                m_scalefac(ch).l(11) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(12) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(13) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(14) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(15) = m_BitReserve.GetBits(length1)
            End If
            If m_SideInfo.ch(ch).scfsi(3) = 0 OrElse gr = 0 Then
                m_scalefac(ch).l(16) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(17) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(18) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(19) = m_BitReserve.GetBits(length1)
                m_scalefac(ch).l(20) = m_BitReserve.GetBits(length1)
            End If

            m_scalefac(ch).l(21) = 0
            m_scalefac(ch).l(22) = 0
        End If

    End Sub

    Private Sub HuffmanDecode(ByVal ch As Integer, ByVal gr As Integer)
        Dim m_x, m_y, m_v, m_w As Integer

        Dim part2_3_end As Integer = m_part2_start + m_SideInfo.ch(ch).gr(gr).part2_3_length
        Dim num_bits As Integer = 0
        Dim region1Start As Integer = 0
        Dim region2Start As Integer = 0
        Dim index As Integer = 0

        Dim buf, buf1 As Integer

        Dim Tbl As HuffcodeTable

        ' Find region boundary for short block case

        If m_SideInfo.ch(ch).gr(gr).window_switching_flag <> 0 AndAlso m_SideInfo.ch(ch).gr(gr).block_type = 2 Then
            ' Extrahandling for 8KHZ
            If m_sfreq = 8 Then
                region1Start = 72
            Else
                region1Start = 36
            End If
            region2Start = 576
        Else
            ' Find region boundary for long block case
            buf = m_SideInfo.ch(ch).gr(gr).region0_count + 1
            buf1 = buf + m_SideInfo.ch(ch).gr(gr).region1_count + 1

            If buf1 > m_sfBandIndex(m_sfreq).l.Length - 1 Then
                buf1 = m_sfBandIndex(m_sfreq).l.Length - 1
            End If
            region1Start = m_sfBandIndex(m_sfreq).l(buf)
            region2Start = m_sfBandIndex(m_sfreq).l(buf1)
        End If

        ' Read bigvalues area
        index = 0
        Dim i As Integer = 0
        Dim bvTB1 As Integer = (m_SideInfo.ch(ch).gr(gr).big_values << 1)

        While i < bvTB1
            If i < region1Start Then
                Tbl = m_Tabs.Tables(m_SideInfo.ch(ch).gr(gr).table_select(0))
            ElseIf i < region2Start Then
                Tbl = m_Tabs.Tables(m_SideInfo.ch(ch).gr(gr).table_select(1))
            Else
                Tbl = m_Tabs.Tables(m_SideInfo.ch(ch).gr(gr).table_select(2))
            End If
            Tbl.HuffmanDecode(m_x, m_y, m_v, m_w, m_BitReserve)

            m_is_1d(index) = m_x
            index += 1
            m_is_1d(index) = m_y
            index += 1
            i += 2
        End While

        ' Read count1 area
        Tbl = m_Tabs.Tables(m_SideInfo.ch(ch).gr(gr).count1table_select + 32)
        num_bits = m_BitReserve.SSTell()

        While num_bits < part2_3_end AndAlso index < 576
            Tbl.HuffmanDecode(m_x, m_y, m_v, m_w, m_BitReserve)

            m_is_1d(index) = m_v
            index += 1
            m_is_1d(index) = m_w
            index += 1
            m_is_1d(index) = m_x
            index += 1
            m_is_1d(index) = m_y
            index += 1
            num_bits = m_BitReserve.SSTell()
        End While

        If num_bits > part2_3_end Then
            m_BitReserve.RewindNBits(num_bits - part2_3_end)
            index -= 4
        End If

        num_bits = m_BitReserve.SSTell()

        ' Dismiss stuffing bits
        If num_bits < part2_3_end Then
            m_BitReserve.GetBits(part2_3_end - num_bits)
        End If

        ' Zero out rest
        If index < 576 Then
            m_nonzero(ch) = index
        Else
            m_nonzero(ch) = 576
        End If
        If index < 0 Then
            index = 0
        End If

        While index < 576
            m_is_1d(index) = 0
            index += 1
        End While

    End Sub

    Private Sub IStereoKValues(ByVal is_pos As Integer, ByVal io_type As Integer, ByVal i As Integer)
        If is_pos = 0 Then
            m_k(0)(i) = 1.0F
            m_k(1)(i) = 1.0F
        ElseIf (is_pos And 1) <> 0 Then
            m_k(0)(i) = m_io(io_type)(Common.URShift(is_pos + 1, 1))
            m_k(1)(i) = 1.0F
        Else
            m_k(0)(i) = 1.0F
            m_k(1)(i) = m_io(io_type)(Common.URShift(is_pos, 1))
        End If

    End Sub

    Private Sub DequantizeSample(ByVal xr()() As Single, ByVal ch As Integer, ByVal gr As Integer)
        Dim gr_info As GroupInfo = m_SideInfo.ch(ch).gr(gr)
        Dim cb As Integer = 0
        Dim next_cb_boundary As Integer = 0
        Dim cb_begin As Integer = 0
        Dim cb_width As Integer = 0
        Dim index As Integer = 0
        Dim t_index, j As Integer
        Dim g_gain As Single
        Dim xr_1d As Single()() = xr

        ' choose correct scalefactor band per block type, initalize boundary
        If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 Then
            If gr_info.mixed_block_flag <> 0 Then
                next_cb_boundary = m_sfBandIndex(m_sfreq).l(1)
                ' long blocks: 0, 1, 3
            Else
                cb_width = m_sfBandIndex(m_sfreq).s(1)
                next_cb_boundary = (cb_width << 2) - cb_width
                cb_begin = 0
            End If
        Else
            ' long blocks: 0, 1, 3
            next_cb_boundary = m_sfBandIndex(m_sfreq).l(1)
        End If

        ' Compute overall (global) scaling.
        g_gain = System.Convert.ToSingle(Math.Pow(2.0, 0.25 * (gr_info.global_gain - 210.0)))

        j = 0

        ' apply formula per block type
        While j < m_nonzero(ch)
            Dim reste As Integer = j Mod 18
            Dim quotien As Integer = (j - reste) \ 18
            If m_is_1d(j) = 0 Then
                xr_1d(quotien)(reste) = 0.0F
            Else
                Dim abv As Integer = m_is_1d(j)
                If m_is_1d(j) > 0 Then
                    xr_1d(quotien)(reste) = g_gain * m_t_43(abv)
                Else
                    xr_1d(quotien)(reste) = -g_gain * m_t_43(-abv)
                End If
            End If
            j += 1
        End While

        j = 0

        While j < m_nonzero(ch)
            Dim reste As Integer = j Mod 18
            Dim quotien As Integer = (j - reste) \ 18

            If index = next_cb_boundary Then
                ' Adjust critical band boundary
                If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 Then
                    If gr_info.mixed_block_flag <> 0 Then
                        If index = m_sfBandIndex(m_sfreq).l(8) Then
                            next_cb_boundary = m_sfBandIndex(m_sfreq).s(4)
                            next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary
                            cb = 3
                            cb_width = m_sfBandIndex(m_sfreq).s(4) - m_sfBandIndex(m_sfreq).s(3)

                            cb_begin = m_sfBandIndex(m_sfreq).s(3)
                            cb_begin = (cb_begin << 2) - cb_begin
                        ElseIf index < m_sfBandIndex(m_sfreq).l(8) Then
                            cb += 1
                            next_cb_boundary = m_sfBandIndex(m_sfreq).l((cb + 1))
                        Else
                            cb += 1
                            next_cb_boundary = m_sfBandIndex(m_sfreq).s((cb + 1))
                            next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary

                            cb_begin = m_sfBandIndex(m_sfreq).s(cb)
                            cb_width = m_sfBandIndex(m_sfreq).s((cb + 1)) - cb_begin
                            cb_begin = (cb_begin << 2) - cb_begin
                        End If
                    Else
                        cb += 1
                        next_cb_boundary = m_sfBandIndex(m_sfreq).s((cb + 1))
                        next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary

                        cb_begin = m_sfBandIndex(m_sfreq).s(cb)
                        cb_width = m_sfBandIndex(m_sfreq).s((cb + 1)) - cb_begin
                        cb_begin = (cb_begin << 2) - cb_begin
                    End If
                Else
                    ' long blocks
                    cb += 1
                    next_cb_boundary = m_sfBandIndex(m_sfreq).l((cb + 1))
                End If
            End If

            ' Do long/short dependent scaling operations
            If gr_info.window_switching_flag <> 0 AndAlso (gr_info.block_type = 2 AndAlso gr_info.mixed_block_flag = 0 OrElse (gr_info.block_type = 2 AndAlso gr_info.mixed_block_flag <> 0 AndAlso j >= 36)) Then
                t_index = (index - cb_begin) \ cb_width
                Dim idx As Integer = (m_scalefac(ch).s(t_index)(cb) << gr_info.scalefac_scale)
                idx += (gr_info.subblock_gain(t_index) << 2)

                xr_1d(quotien)(reste) *= m_two_to_negative_half_pow(idx)
            Else
                ' long block types 0, 1, 3 & 1st 2 subbands of switched blocks
                Dim idx As Integer = m_scalefac(ch).l(cb)

                If gr_info.preflag <> 0 Then
                    idx += m_pretab(cb)
                End If
                idx = (idx << gr_info.scalefac_scale)
                xr_1d(quotien)(reste) *= m_two_to_negative_half_pow(idx)
            End If
            index += 1
            j += 1
        End While

        j = m_nonzero(ch)

        While j < 576
            Dim reste As Integer = j Mod 18
            Dim quotien As Integer = (j - reste) \ 18
            If reste < 0 Then
                reste = 0
            End If
            If quotien < 0 Then
                quotien = 0
            End If
            xr_1d(quotien)(reste) = 0.0F
            j += 1
        End While

        Return

    End Sub

    Private Overloads Sub Reorder(ByVal xr()() As Single, ByVal ch As Integer, ByVal gr As Integer)
        Dim gr_info As GroupInfo = m_SideInfo.ch(ch).gr(gr)
        Dim freq, freq3 As Integer
        Dim index As Integer = 0
        Dim sfb, sfb_start, sfb_lines As Integer
        Dim src_line, des_line As Integer
        Dim xr_1d As Single()() = xr

        If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 Then
            index = 0

            While index < 576
                m_out_1d(index) = 0.0F
                index += 1
            End While

            If gr_info.mixed_block_flag <> 0 Then
                ' no reorder for low 2 subbands
                index = 0

                While index < 36
                    Dim reste As Integer = index Mod 18
                    Dim quotien As Integer = (index - reste) \ 18
                    m_out_1d(index) = xr_1d(quotien)(reste)
                    index += 1
                End While

                ' reordering for rest switched short
                sfb = 3
                sfb_start = m_sfBandIndex(m_sfreq).s(3)
                sfb_lines = m_sfBandIndex(m_sfreq).s(4) - sfb_start

                While sfb < 13
                    Dim sfb_start3 As Integer = (sfb_start << 2) - sfb_start
                    freq = 0
                    freq3 = 0

                    While freq < sfb_lines
                        src_line = sfb_start3 + freq
                        des_line = sfb_start3 + freq3
                        Dim reste As Integer = src_line Mod 18
                        Dim quotien As Integer = (src_line - reste) \ 18

                        m_out_1d(des_line) = xr_1d(quotien)(reste)
                        src_line += sfb_lines
                        des_line += 1

                        reste = src_line Mod 18
                        quotien = (src_line - reste) \ 18

                        m_out_1d(des_line) = xr_1d(quotien)(reste)
                        src_line += sfb_lines
                        des_line += 1

                        reste = src_line Mod 18
                        quotien = (src_line - reste) \ 18

                        m_out_1d(des_line) = xr_1d(quotien)(reste)
                        freq3 += 3
                        freq += 1
                    End While
                    sfb_start = m_sfBandIndex(m_sfreq).s(sfb)
                    sfb_lines = m_sfBandIndex(m_sfreq).s((sfb + 1)) - sfb_start
                    sfb += 1
                End While
            Else
                ' pure short
                index = 0

                While index < 576
                    Dim j As Integer = m_reorder_table(m_sfreq)(index)
                    Dim reste As Integer = j Mod 18
                    Dim quotien As Integer = (j - reste) \ 18
                    m_out_1d(index) = xr_1d(quotien)(reste)
                    index += 1
                End While
            End If
        Else
            ' long blocks
            index = 0

            While index < 576
                Dim reste As Integer = index Mod 18
                Dim quotien As Integer = (index - reste) \ 18
                m_out_1d(index) = xr_1d(quotien)(reste)
                index += 1
            End While
        End If

    End Sub

    Private Overloads Function Reorder(ByVal scalefac_band() As Integer) As Integer()
        Dim j As Integer = 0
        Dim ix(575) As Integer
        Dim sfb As Integer = 0

        While sfb < 13
            Dim start As Integer = scalefac_band(sfb)
            Dim [end] As Integer = scalefac_band((sfb + 1))
            Dim window As Integer = 0

            While window < 3
                Dim i As Integer = start

                While i < [end]
                    ix((3 * i + window)) = j
                    j += 1
                    i += 1
                End While
                window += 1
            End While
            sfb += 1
        End While


        Return ix

    End Function

    Private Sub Stereo(ByVal gr As Integer)
        Dim sb, ss As Integer

        If m_channels = 1 Then
            ' mono ,bypass
            sb = 0

            While sb < 32
                ss = 0

                While ss < 18
                    m_lr(0)(sb)(ss) = m_ro(0)(sb)(ss)
                    m_lr(0)(sb)((ss + 1)) = m_ro(0)(sb)((ss + 1))
                    m_lr(0)(sb)((ss + 2)) = m_ro(0)(sb)((ss + 2))
                    ss += 3
                End While
                sb += 1
            End While

        Else
            Dim gr_info As GroupInfo = m_SideInfo.ch(0).gr(gr)
            Dim mode_ext As Integer = m_header.ModeExtension()
            Dim sfb As Integer = 0
            Dim i As Integer = 0
            Dim lines, temp, temp2 As Integer

            Dim ms_stereo As Boolean = m_header.Mode() = FrameHeader.JOINT_STEREO AndAlso (mode_ext And &H2) <> 0
            Dim i_stereo As Boolean = m_header.Mode() = FrameHeader.JOINT_STEREO AndAlso (mode_ext And &H1) <> 0
            Dim lsf As Boolean = False '= m_header.Version() = FrameHeader.MPEG2_LSF OrElse m_header.Version() = FrameHeader.MPEG25_LSF

            Dim io_type As Integer = gr_info.scalefac_compress And 1

            i = 0
            ' initialization
            While i < 576
                m_is_pos(i) = 7

                m_is_ratio(i) = 0.0F
                i += 1
            End While

            If i_stereo Then
                If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 Then
                    If gr_info.mixed_block_flag <> 0 Then
                        Dim max_sfb As Integer = 0
                        Dim j As Integer = 0

                        While j < 3
                            Dim sfbcnt As Integer = 0
                            sfbcnt = 2
                            sfb = 12

                            While sfb >= 3
                                i = m_sfBandIndex(m_sfreq).s(sfb)
                                lines = m_sfBandIndex(m_sfreq).s((sfb + 1)) - i
                                i = (i << 2) - i + (j + 1) * lines - 1

                                While lines > 0
                                    If m_ro(1)((i \ 18))((i Mod 18)) <> 0.0F Then
                                        sfbcnt = sfb
                                        sfb = -10
                                        lines = -10
                                    End If

                                    lines -= 1
                                    i -= 1
                                End While
                                sfb -= 1
                            End While
                            sfb = sfbcnt + 1

                            If sfb > max_sfb Then
                                max_sfb = sfb
                            End If
                            While sfb < 12
                                temp = m_sfBandIndex(m_sfreq).s(sfb)
                                sb = m_sfBandIndex(m_sfreq).s((sfb + 1)) - temp
                                i = (temp << 2) - temp + j * sb


                                While sb > 0
                                    m_is_pos(i) = m_scalefac(1).s(j)(sfb)
                                    If m_is_pos(i) <> 7 Then
                                        If lsf Then
                                            IStereoKValues(m_is_pos(i), io_type, i)
                                        Else
                                            m_is_ratio(i) = m_TAN12(m_is_pos(i))
                                        End If
                                    End If
                                    i += 1
                                    sb -= 1
                                End While
                                sfb += 1
                            End While
                            sfb = m_sfBandIndex(m_sfreq).s(10)
                            sb = m_sfBandIndex(m_sfreq).s(11) - sfb
                            sfb = (sfb << 2) - sfb + j * sb
                            temp = m_sfBandIndex(m_sfreq).s(11)
                            sb = m_sfBandIndex(m_sfreq).s(12) - temp
                            i = (temp << 2) - temp + j * sb


                            While sb > 0
                                m_is_pos(i) = m_is_pos(sfb)

                                If lsf Then
                                    m_k(0)(i) = m_k(0)(sfb)
                                    m_k(1)(i) = m_k(1)(sfb)
                                Else
                                    m_is_ratio(i) = m_is_ratio(sfb)
                                End If
                                i += 1
                                sb -= 1
                            End While
                            j += 1
                        End While
                        If max_sfb <= 3 Then
                            i = 2
                            ss = 17
                            sb = -1
                            While i >= 0
                                If m_ro(1)(i)(ss) <> 0.0F Then
                                    sb = (i << 4) + (i << 1) + ss
                                    i = -1
                                Else
                                    ss -= 1
                                    If ss < 0 Then
                                        i -= 1
                                        ss = 17
                                    End If
                                End If
                            End While
                            i = 0
                            While m_sfBandIndex(m_sfreq).l(i) <= sb
                                i += 1
                            End While
                            sfb = i
                            i = m_sfBandIndex(m_sfreq).l(i)

                            While sfb < 8
                                sb = m_sfBandIndex(m_sfreq).l((sfb + 1)) - m_sfBandIndex(m_sfreq).l(sfb)

                                While sb > 0
                                    m_is_pos(i) = m_scalefac(1).l(sfb)
                                    If m_is_pos(i) <> 7 Then
                                        If lsf Then
                                            IStereoKValues(m_is_pos(i), io_type, i)
                                        Else
                                            m_is_ratio(i) = m_TAN12(m_is_pos(i))
                                        End If
                                    End If
                                    i += 1
                                    sb -= 1
                                End While
                                sfb += 1
                            End While
                        End If

                    Else
                        Dim j As Integer = 0

                        While j < 3
                            Dim sfbcnt As Integer = 0
                            sfbcnt = -1
                            sfb = 12

                            While sfb >= 0
                                temp = m_sfBandIndex(m_sfreq).s(sfb)
                                lines = m_sfBandIndex(m_sfreq).s((sfb + 1)) - temp
                                i = (temp << 2) - temp + (j + 1) * lines - 1

                                While lines > 0
                                    If m_ro(1)((i \ 18))((i Mod 18)) <> 0.0F Then
                                        sfbcnt = sfb
                                        sfb = -10
                                        lines = -10
                                    End If
                                    lines -= 1
                                    i -= 1
                                End While
                                sfb -= 1
                            End While
                            sfb = sfbcnt + 1
                            While sfb < 12
                                temp = m_sfBandIndex(m_sfreq).s(sfb)
                                sb = m_sfBandIndex(m_sfreq).s((sfb + 1)) - temp
                                i = (temp << 2) - temp + j * sb

                                While sb > 0
                                    m_is_pos(i) = m_scalefac(1).s(j)(sfb)
                                    If m_is_pos(i) <> 7 Then
                                        If lsf Then
                                            IStereoKValues(m_is_pos(i), io_type, i)
                                        Else
                                            m_is_ratio(i) = m_TAN12(m_is_pos(i))
                                        End If
                                    End If
                                    i += 1
                                    sb -= 1
                                End While
                                sfb += 1
                            End While

                            temp = m_sfBandIndex(m_sfreq).s(10)
                            temp2 = m_sfBandIndex(m_sfreq).s(11)
                            sb = temp2 - temp
                            sfb = (temp << 2) - temp + j * sb
                            sb = m_sfBandIndex(m_sfreq).s(12) - temp2
                            i = (temp2 << 2) - temp2 + j * sb


                            While sb > 0
                                m_is_pos(i) = m_is_pos(sfb)

                                If lsf Then
                                    m_k(0)(i) = m_k(0)(sfb)
                                    m_k(1)(i) = m_k(1)(sfb)
                                Else
                                    m_is_ratio(i) = m_is_ratio(sfb)
                                End If
                                i += 1
                                sb -= 1
                            End While
                            j += 1
                        End While
                    End If



                Else
                    i = 31
                    ss = 17
                    sb = 0
                    While i >= 0
                        If m_ro(1)(i)(ss) <> 0.0F Then
                            sb = (i << 4) + (i << 1) + ss
                            i = -1
                        Else
                            ss -= 1
                            If ss < 0 Then
                                i -= 1
                                ss = 17
                            End If
                        End If
                    End While
                    i = 0
                    While m_sfBandIndex(m_sfreq).l(i) <= sb
                        i += 1
                    End While
                    sfb = i
                    i = m_sfBandIndex(m_sfreq).l(i)

                    While sfb < 21
                        sb = m_sfBandIndex(m_sfreq).l((sfb + 1)) - m_sfBandIndex(m_sfreq).l(sfb)

                        While sb > 0
                            m_is_pos(i) = m_scalefac(1).l(sfb)
                            If m_is_pos(i) <> 7 Then
                                If lsf Then
                                    IStereoKValues(m_is_pos(i), io_type, i)
                                Else
                                    m_is_ratio(i) = m_TAN12(m_is_pos(i))
                                End If
                            End If
                            i += 1
                            sb -= 1
                        End While
                        sfb += 1
                    End While
                    sfb = m_sfBandIndex(m_sfreq).l(20)
                    sb = 576 - m_sfBandIndex(m_sfreq).l(21)

                    While sb > 0 AndAlso i < 576
                        m_is_pos(i) = m_is_pos(sfb)

                        If lsf Then
                            m_k(0)(i) = m_k(0)(sfb)
                            m_k(1)(i) = m_k(1)(sfb)
                        Else
                            m_is_ratio(i) = m_is_ratio(sfb)
                        End If
                        i += 1
                        sb -= 1
                    End While
                End If
            End If


            i = 0
            sb = 0

            While sb < 32
                ss = 0

                While ss < 18
                    If m_is_pos(i) = 7 Then
                        If ms_stereo Then
                            m_lr(0)(sb)(ss) = (m_ro(0)(sb)(ss) + m_ro(1)(sb)(ss)) * 0.707106769F
                            m_lr(1)(sb)(ss) = (m_ro(0)(sb)(ss) - m_ro(1)(sb)(ss)) * 0.707106769F
                        Else
                            m_lr(0)(sb)(ss) = m_ro(0)(sb)(ss)
                            m_lr(1)(sb)(ss) = m_ro(1)(sb)(ss)
                        End If
                    ElseIf i_stereo Then
                        If lsf Then
                            m_lr(0)(sb)(ss) = m_ro(0)(sb)(ss) * m_k(0)(i)
                            m_lr(1)(sb)(ss) = m_ro(0)(sb)(ss) * m_k(1)(i)
                        Else
                            m_lr(1)(sb)(ss) = m_ro(0)(sb)(ss) \ (1 + m_is_ratio(i))
                            m_lr(0)(sb)(ss) = m_lr(1)(sb)(ss) * m_is_ratio(i)
                        End If
                    End If
                    i += 1
                    ss += 1
                End While
                sb += 1
            End While
        End If

    End Sub

    ' 31 alias-reduction operations between each pair of sub-bands
    ' with 8 butterflies between each pair
    Private Sub Antialias(ByVal ch As Integer, ByVal gr As Integer)
        Dim sb18, ss, sb18lim As Integer
        Dim gr_info As GroupInfo = m_SideInfo.ch(ch).gr(gr)

        If gr_info.window_switching_flag <> 0 AndAlso gr_info.block_type = 2 AndAlso Not gr_info.mixed_block_flag <> 0 Then
            Return
        End If
        If gr_info.window_switching_flag <> 0 AndAlso gr_info.mixed_block_flag <> 0 AndAlso gr_info.block_type = 2 Then
            sb18lim = 18
        Else
            sb18lim = 558
        End If
        sb18 = 0

        While sb18 < sb18lim
            ss = 0

            While ss < 8
                Dim src_idx1 As Integer = sb18 + 17 - ss
                Dim src_idx2 As Integer = sb18 + 18 + ss
                Dim bu As Single = m_out_1d(src_idx1)
                Dim bd As Single = m_out_1d(src_idx2)
                m_out_1d(src_idx1) = bu * m_cs(ss) - bd * m_ca(ss)
                m_out_1d(src_idx2) = bd * m_cs(ss) + bu * m_ca(ss)
                ss += 1
            End While
            sb18 += 18
        End While

    End Sub

    Private Sub Hybrid(ByVal ch As Integer, ByVal gr As Integer)
        Dim bt As Integer = 0
        Dim sb18 As Integer = 0
        Dim gr_info As GroupInfo = m_SideInfo.ch(ch).gr(gr)
        Dim tsOut() As Single

        Dim prvblk()() As Single

        sb18 = 0

        While sb18 < 576
            If gr_info.window_switching_flag <> 0 AndAlso gr_info.mixed_block_flag <> 0 AndAlso sb18 < 36 Then
                bt = 0
            Else
                bt = gr_info.block_type
            End If
            tsOut = m_out_1d

            Dim cc As Integer = 0

            While cc < 18
                m_tsOutCopy(cc) = tsOut((cc + sb18))
                cc += 1
            End While

            InvMdct(m_tsOutCopy, m_rawout, bt)

            cc = 0

            While cc < 18
                tsOut((cc + sb18)) = m_tsOutCopy(cc)
                cc += 1
            End While

            prvblk = m_prevblck

            tsOut((0 + sb18)) = m_rawout(0) + prvblk(ch)((sb18 + 0))
            prvblk(ch)((sb18 + 0)) = m_rawout(18)
            tsOut((1 + sb18)) = m_rawout(1) + prvblk(ch)((sb18 + 1))
            prvblk(ch)((sb18 + 1)) = m_rawout(19)
            tsOut((2 + sb18)) = m_rawout(2) + prvblk(ch)((sb18 + 2))
            prvblk(ch)((sb18 + 2)) = m_rawout(20)
            tsOut((3 + sb18)) = m_rawout(3) + prvblk(ch)((sb18 + 3))
            prvblk(ch)((sb18 + 3)) = m_rawout(21)
            tsOut((4 + sb18)) = m_rawout(4) + prvblk(ch)((sb18 + 4))
            prvblk(ch)((sb18 + 4)) = m_rawout(22)
            tsOut((5 + sb18)) = m_rawout(5) + prvblk(ch)((sb18 + 5))
            prvblk(ch)((sb18 + 5)) = m_rawout(23)
            tsOut((6 + sb18)) = m_rawout(6) + prvblk(ch)((sb18 + 6))
            prvblk(ch)((sb18 + 6)) = m_rawout(24)
            tsOut((7 + sb18)) = m_rawout(7) + prvblk(ch)((sb18 + 7))
            prvblk(ch)((sb18 + 7)) = m_rawout(25)
            tsOut((8 + sb18)) = m_rawout(8) + prvblk(ch)((sb18 + 8))
            prvblk(ch)((sb18 + 8)) = m_rawout(26)
            tsOut((9 + sb18)) = m_rawout(9) + prvblk(ch)((sb18 + 9))
            prvblk(ch)((sb18 + 9)) = m_rawout(27)
            tsOut((10 + sb18)) = m_rawout(10) + prvblk(ch)((sb18 + 10))
            prvblk(ch)((sb18 + 10)) = m_rawout(28)
            tsOut((11 + sb18)) = m_rawout(11) + prvblk(ch)((sb18 + 11))
            prvblk(ch)((sb18 + 11)) = m_rawout(29)
            tsOut((12 + sb18)) = m_rawout(12) + prvblk(ch)((sb18 + 12))
            prvblk(ch)((sb18 + 12)) = m_rawout(30)
            tsOut((13 + sb18)) = m_rawout(13) + prvblk(ch)((sb18 + 13))
            prvblk(ch)((sb18 + 13)) = m_rawout(31)
            tsOut((14 + sb18)) = m_rawout(14) + prvblk(ch)((sb18 + 14))
            prvblk(ch)((sb18 + 14)) = m_rawout(32)
            tsOut((15 + sb18)) = m_rawout(15) + prvblk(ch)((sb18 + 15))
            prvblk(ch)((sb18 + 15)) = m_rawout(33)
            tsOut((16 + sb18)) = m_rawout(16) + prvblk(ch)((sb18 + 16))
            prvblk(ch)((sb18 + 16)) = m_rawout(34)
            tsOut((17 + sb18)) = m_rawout(17) + prvblk(ch)((sb18 + 17))
            prvblk(ch)((sb18 + 17)) = m_rawout(35)
            sb18 += 18
        End While

    End Sub

    Private Sub DoDownmix()
        Dim sb As Integer = 0

        While sb < 18
            Dim ss As Integer = 0

            While ss < 18
                m_lr(0)(sb)(ss) = (m_lr(0)(sb)(ss) + m_lr(1)(sb)(ss)) * 0.5F
                m_lr(0)(sb)((ss + 1)) = (m_lr(0)(sb)((ss + 1)) + m_lr(1)(sb)((ss + 1))) * 0.5F
                m_lr(0)(sb)((ss + 2)) = (m_lr(0)(sb)((ss + 2)) + m_lr(1)(sb)((ss + 2))) * 0.5F
                ss += 3
            End While
            sb += 1
        End While

    End Sub

    Private Sub InvMdct(ByVal in_Renamed() As Single, ByVal out_Renamed() As Single, ByVal block_type As Integer)
        Dim win_bt() As Single
        Dim i As Integer = 0

        Dim tmpf_0, tmpf_1, tmpf_2, tmpf_3, tmpf_4, tmpf_5, tmpf_6, tmpf_7, tmpf_8, tmpf_9, _
        tmpf_10, tmpf_11, tmpf_12, tmpf_13, tmpf_14, tmpf_15, tmpf_16, tmpf_17 As Single


        If block_type = 2 Then
            For i = 0 To 35
                out_Renamed(i) = 0.0F
            Next

            Dim six_i As Integer = 0

            i = 0

            While i < 3
                ' 12 point IMDCT
                ' Begin 12 point IDCT
                ' Input aliasing for 12 pt IDCT
                in_Renamed((15 + i)) += in_Renamed((12 + i))
                in_Renamed((12 + i)) += in_Renamed((9 + i))
                in_Renamed((9 + i)) += in_Renamed((6 + i))
                in_Renamed((6 + i)) += in_Renamed((3 + i))
                in_Renamed((3 + i)) += in_Renamed((0 + i))

                ' Input aliasing on odd indices (for 6 point IDCT)
                in_Renamed((15 + i)) += in_Renamed((9 + i))
                in_Renamed((9 + i)) += in_Renamed((3 + i))

                ' 3 point IDCT on even indices
                Dim pp1, pp2, sum As Single
                pp2 = in_Renamed((12 + i)) * 0.5F
                pp1 = in_Renamed((6 + i)) * 0.8660254F
                sum = in_Renamed((0 + i)) + pp2

                tmpf_1 = in_Renamed((0 + i)) - in_Renamed((12 + i))
                tmpf_0 = sum + pp1
                tmpf_2 = sum - pp1

                ' End 3 point IDCT on even indices
                ' 3 point IDCT on odd indices (for 6 point IDCT)
                pp2 = in_Renamed((15 + i)) * 0.5F
                pp1 = in_Renamed((9 + i)) * 0.8660254F
                sum = in_Renamed((3 + i)) + pp2

                tmpf_4 = in_Renamed((3 + i)) - in_Renamed((15 + i))
                tmpf_5 = sum + pp1
                tmpf_3 = sum - pp1
                ' End 3 point IDCT on odd indices
                ' Twiddle factors on odd indices (for 6 point IDCT)

                tmpf_3 *= 1.93185163F
                tmpf_4 *= 0.707106769F
                tmpf_5 *= 0.5176381F

                ' Output butterflies on 2 3 point IDCT' s (for 6 point IDCT)
                Dim save As Single = tmpf_0
                tmpf_0 += tmpf_5
                tmpf_5 = save - tmpf_5
                save = tmpf_1
                tmpf_1 += tmpf_4
                tmpf_4 = save - tmpf_4
                save = tmpf_2
                tmpf_2 += tmpf_3
                tmpf_3 = save - tmpf_3

                ' End 6 point IDCT
                ' Twiddle factors on indices (for 12 point IDCT)

                tmpf_0 *= 0.5043145F
                tmpf_1 *= 0.5411961F
                tmpf_2 *= 0.6302362F
                tmpf_3 *= 0.8213398F
                tmpf_4 *= 1.306563F
                tmpf_5 *= 3.830649F

                ' End 12 point IDCT

                ' Shift to 12 point modified IDCT, multiply by window type 2
                tmpf_8 = -tmpf_0 * 0.7933533F
                tmpf_9 = -tmpf_0 * 0.6087614F
                tmpf_7 = -tmpf_1 * 0.9238795F
                tmpf_10 = -tmpf_1 * 0.382683426F
                tmpf_6 = -tmpf_2 * 0.9914449F
                tmpf_11 = -tmpf_2 * 0.130526185F

                tmpf_0 = tmpf_3
                tmpf_1 = tmpf_4 * 0.382683426F
                tmpf_2 = tmpf_5 * 0.6087614F

                tmpf_3 = -tmpf_5 * 0.7933533F
                tmpf_4 = -tmpf_4 * 0.9238795F
                tmpf_5 = -tmpf_0 * 0.9914449F

                tmpf_0 *= 0.130526185F

                out_Renamed((six_i + 6)) += tmpf_0
                out_Renamed((six_i + 7)) += tmpf_1
                out_Renamed((six_i + 8)) += tmpf_2
                out_Renamed((six_i + 9)) += tmpf_3
                out_Renamed((six_i + 10)) += tmpf_4
                out_Renamed((six_i + 11)) += tmpf_5
                out_Renamed((six_i + 12)) += tmpf_6
                out_Renamed((six_i + 13)) += tmpf_7
                out_Renamed((six_i + 14)) += tmpf_8
                out_Renamed((six_i + 15)) += tmpf_9
                out_Renamed((six_i + 16)) += tmpf_10
                out_Renamed((six_i + 17)) += tmpf_11

                six_i += 6
                i += 1
            End While
        Else
            ' 36 point IDCT
            ' input aliasing for 36 point IDCT
            in_Renamed(17) += in_Renamed(16)
            in_Renamed(16) += in_Renamed(15)
            in_Renamed(15) += in_Renamed(14)
            in_Renamed(14) += in_Renamed(13)
            in_Renamed(13) += in_Renamed(12)
            in_Renamed(12) += in_Renamed(11)
            in_Renamed(11) += in_Renamed(10)
            in_Renamed(10) += in_Renamed(9)
            in_Renamed(9) += in_Renamed(8)
            in_Renamed(8) += in_Renamed(7)
            in_Renamed(7) += in_Renamed(6)
            in_Renamed(6) += in_Renamed(5)
            in_Renamed(5) += in_Renamed(4)
            in_Renamed(4) += in_Renamed(3)
            in_Renamed(3) += in_Renamed(2)
            in_Renamed(2) += in_Renamed(1)
            in_Renamed(1) += in_Renamed(0)

            ' 18 point IDCT for odd indices
            ' input aliasing for 18 point IDCT
            in_Renamed(17) += in_Renamed(15)
            in_Renamed(15) += in_Renamed(13)
            in_Renamed(13) += in_Renamed(11)
            in_Renamed(11) += in_Renamed(9)
            in_Renamed(9) += in_Renamed(7)
            in_Renamed(7) += in_Renamed(5)
            in_Renamed(5) += in_Renamed(3)
            in_Renamed(3) += in_Renamed(1)

            Dim tmp0, tmp1, tmp2, tmp3, tmp4, _
            tmp0_, tmp1_, tmp2_, tmp3_, _
            tmp0o, tmp1o, tmp2o, tmp3o, tmp4o, tmp0_o, tmp1_o, tmp2_o, tmp3_o As Single

            ' Fast 9 Point Inverse Discrete Cosine Transform
            ' By  Francois-Raymond Boyer
            '   mailto:boyerf@iro.umontreal.ca
            '   http://www.iro.umontreal.ca/~boyerf
            ' 
            ' The code has been optimized for Intel processors
            ' (takes a lot of time to convert float to and from iternal FPU representation)
            ' It is a simple "factorization" of the IDCT matrix.

            ' 9 point IDCT on even indices
            ' 5 points on odd indices (not realy an IDCT)
            Dim i00 As Single = in_Renamed(0) + in_Renamed(0)
            Dim iip12 As Single = i00 + in_Renamed(12)

            tmp0 = iip12 + in_Renamed(4) * 1.87938523F + in_Renamed(8) * 1.53208888F + in_Renamed(16) * 0.347296357F
            tmp1 = i00 + in_Renamed(4) - in_Renamed(8) - in_Renamed(12) - in_Renamed(12) - in_Renamed(16)
            tmp2 = iip12 - in_Renamed(4) * 0.347296357F - in_Renamed(8) * 1.87938523F + in_Renamed(16) * 1.53208888F
            tmp3 = iip12 - in_Renamed(4) * 1.53208888F + in_Renamed(8) * 0.347296357F - in_Renamed(16) * 1.87938523F
            tmp4 = in_Renamed(0) - in_Renamed(4) + in_Renamed(8) - in_Renamed(12) + in_Renamed(16)

            ' 4 points on even indices
            Dim i66_ As Single = in_Renamed(6) * 1.73205078F


            tmp0_ = in_Renamed(2) * 1.96961546F + i66_ + in_Renamed(10) * 1.28557527F + in_Renamed(14) * 0.6840403F
            tmp1_ = (in_Renamed(2) - in_Renamed(10) - in_Renamed(14)) * 1.73205078F
            tmp2_ = in_Renamed(2) * 1.28557527F - i66_ - in_Renamed(10) * 0.6840403F + in_Renamed(14) * 1.96961546F
            tmp3_ = in_Renamed(2) * 0.6840403F - i66_ + in_Renamed(10) * 1.96961546F - in_Renamed(14) * 1.28557527F

            ' 9 point IDCT on odd indices
            ' 5 points on odd indices (not realy an IDCT)
            Dim i0 As Single = in_Renamed((0 + 1)) + in_Renamed((0 + 1))
            Dim i0p12 As Single = i0 + in_Renamed((12 + 1))

            tmp0o = i0p12 + in_Renamed((4 + 1)) * 1.87938523F + in_Renamed((8 + 1)) * 1.53208888F + in_Renamed((16 + 1)) * 0.347296357F
            tmp1o = i0 + in_Renamed((4 + 1)) - in_Renamed((8 + 1)) - in_Renamed((12 + 1)) - in_Renamed((12 + 1)) - in_Renamed((16 + 1))
            tmp2o = i0p12 - in_Renamed((4 + 1)) * 0.347296357F - in_Renamed((8 + 1)) * 1.87938523F + in_Renamed((16 + 1)) * 1.53208888F
            tmp3o = i0p12 - in_Renamed((4 + 1)) * 1.53208888F + in_Renamed((8 + 1)) * 0.347296357F - in_Renamed((16 + 1)) * 1.87938523F
            tmp4o = (in_Renamed((0 + 1)) - in_Renamed((4 + 1)) + in_Renamed((8 + 1)) - in_Renamed((12 + 1)) + in_Renamed((16 + 1))) * 0.707106769F

            ' 4 points on even indices
            Dim i6_ As Single = in_Renamed((6 + 1)) * 1.73205078F

            tmp0_o = in_Renamed((2 + 1)) * 1.96961546F + i6_ + in_Renamed((10 + 1)) * 1.28557527F + in_Renamed((14 + 1)) * 0.6840403F
            tmp1_o = (in_Renamed((2 + 1)) - in_Renamed((10 + 1)) - in_Renamed((14 + 1))) * 1.73205078F
            tmp2_o = in_Renamed((2 + 1)) * 1.28557527F - i6_ - in_Renamed((10 + 1)) * 0.6840403F + in_Renamed((14 + 1)) * 1.96961546F
            tmp3_o = in_Renamed((2 + 1)) * 0.6840403F - i6_ + in_Renamed((10 + 1)) * 1.96961546F - in_Renamed((14 + 1)) * 1.28557527F

            ' Twiddle factors on odd indices and
            ' Butterflies on 9 point IDCT' s and
            ' twiddle factors for 36 point IDCT
            Dim e, o As Single
            e = tmp0 + tmp0_
            o = (tmp0o + tmp0_o) * 0.5019099F
            tmpf_0 = e + o

            tmpf_17 = e - o
            e = tmp1 + tmp1_
            o = (tmp1o + tmp1_o) * 0.5176381F
            tmpf_1 = e + o

            tmpf_16 = e - o
            e = tmp2 + tmp2_
            o = (tmp2o + tmp2_o) * 0.551688969F
            tmpf_2 = e + o

            tmpf_15 = e - o
            e = tmp3 + tmp3_
            o = (tmp3o + tmp3_o) * 0.610387266F
            tmpf_3 = e + o

            tmpf_14 = e - o
            tmpf_4 = tmp4 + tmp4o
            tmpf_13 = tmp4 - tmp4o
            e = tmp3 - tmp3_
            o = (tmp3o - tmp3_o) * 0.8717234F
            tmpf_5 = e + o

            tmpf_12 = e - o
            e = tmp2 - tmp2_
            o = (tmp2o - tmp2_o) * 1.18310082F
            tmpf_6 = e + o

            tmpf_11 = e - o
            e = tmp1 - tmp1_
            o = (tmp1o - tmp1_o) * 1.93185163F
            tmpf_7 = e + o

            tmpf_10 = e - o
            e = tmp0 - tmp0_
            o = (tmp0o - tmp0_o) * 5.73685646F
            tmpf_8 = e + o

            tmpf_9 = e - o

            ' end 36 point IDCT 
            ' shift to modified IDCT
            win_bt = m_win(block_type)

            out_Renamed(0) = -tmpf_9 * win_bt(0)
            out_Renamed(1) = -tmpf_10 * win_bt(1)
            out_Renamed(2) = -tmpf_11 * win_bt(2)
            out_Renamed(3) = -tmpf_12 * win_bt(3)
            out_Renamed(4) = -tmpf_13 * win_bt(4)
            out_Renamed(5) = -tmpf_14 * win_bt(5)
            out_Renamed(6) = -tmpf_15 * win_bt(6)
            out_Renamed(7) = -tmpf_16 * win_bt(7)
            out_Renamed(8) = -tmpf_17 * win_bt(8)
            out_Renamed(9) = tmpf_17 * win_bt(9)
            out_Renamed(10) = tmpf_16 * win_bt(10)
            out_Renamed(11) = tmpf_15 * win_bt(11)
            out_Renamed(12) = tmpf_14 * win_bt(12)
            out_Renamed(13) = tmpf_13 * win_bt(13)
            out_Renamed(14) = tmpf_12 * win_bt(14)
            out_Renamed(15) = tmpf_11 * win_bt(15)
            out_Renamed(16) = tmpf_10 * win_bt(16)
            out_Renamed(17) = tmpf_9 * win_bt(17)
            out_Renamed(18) = tmpf_8 * win_bt(18)
            out_Renamed(19) = tmpf_7 * win_bt(19)
            out_Renamed(20) = tmpf_6 * win_bt(20)
            out_Renamed(21) = tmpf_5 * win_bt(21)
            out_Renamed(22) = tmpf_4 * win_bt(22)
            out_Renamed(23) = tmpf_3 * win_bt(23)
            out_Renamed(24) = tmpf_2 * win_bt(24)
            out_Renamed(25) = tmpf_1 * win_bt(25)
            out_Renamed(26) = tmpf_0 * win_bt(26)
            out_Renamed(27) = tmpf_0 * win_bt(27)
            out_Renamed(28) = tmpf_1 * win_bt(28)
            out_Renamed(29) = tmpf_2 * win_bt(29)
            out_Renamed(30) = tmpf_3 * win_bt(30)
            out_Renamed(31) = tmpf_4 * win_bt(31)
            out_Renamed(32) = tmpf_5 * win_bt(32)
            out_Renamed(33) = tmpf_6 * win_bt(33)
            out_Renamed(34) = tmpf_7 * win_bt(34)
            out_Renamed(35) = tmpf_8 * win_bt(35)
        End If

    End Sub

#End Region

#Region " More Private Variables "
    Private m_slen As Integer()() = {New Integer() {0, 0, 0, 0, 3, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4}, New Integer() {0, 1, 2, 3, 0, 1, 2, 3, 1, 2, 3, 1, 2, 3, 2, 3}}
    Private m_pretab() As Integer = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 3, 2, 0}
    Private m_two_to_negative_half_pow() As Single = {1.0F, 0.707106769F, 0.5F, 0.353553385F, 0.25F, 0.176776692F, 0.125F, 0.0883883461F, 0.0625F, 0.0441941731F, 0.03125F, 0.0220970865F, 0.015625F, 0.0110485433F, 0.0078125F, 0.00552427163F, 0.00390625F, 0.00276213582F, 0.001953125F, 0.00138106791F, 0.0009765625F, 0.000690533954F, 0.00048828125F, 0.000345266977F, 0.000244140625F, 0.000172633489F, 0.000122070313F, 0.0000863167443F, 0.0000610351563F, 0.0000431583721F, 0.0000305175781F, 0.0000215791861F, 0.0000152587891F, 0.000010789593F, 0.00000762939453F, 0.00000539479652F, 0.00000381469727F, 0.00000269739826F, 0.00000190734863F, 0.00000134869913F, 0.0000009536743F, 0.000000674349565F, 0.000000476837158F, 0.000000337174782F, 0.000000238418579F, 0.000000168587391F, 0.00000011920929F, 0.0000000842936956F, 0.0000000596046448F, 0.0000000421468478F, 0.0000000298023224F, 0.0000000210734239F, 0.0000000149011612F, 0.0000000105367119F, 7.450581E-9F, 5.268356E-9F, 0.0000000037252903F, 2.634178E-9F, 0.00000000186264515F, 1.317089E-9F, 9.313226E-10F, 6.585445E-10F, 4.656613E-10F, 0.000000000329272248F}
    Private m_io As Single()() = {New Single() {1.0F, 0.8408964F, 0.707106769F, 0.594603539F, 0.5F, 0.4204482F, 0.353553385F, 0.297301769F, 0.25F, 0.2102241F, 0.176776692F, 0.148650885F, 0.125F, 0.105112053F, 0.0883883461F, 0.07432544F, 0.0625F, 0.0525560267F, 0.0441941731F, 0.03716272F, 0.03125F, 0.0262780134F, 0.0220970865F, 0.01858136F, 0.015625F, 0.0131390067F, 0.0110485433F, 0.00929068F, 0.0078125F, 0.00656950334F, 0.00552427163F, 0.00464534F}, New Single() {1.0F, 0.707106769F, 0.5F, 0.353553385F, 0.25F, 0.176776692F, 0.125F, 0.0883883461F, 0.0625F, 0.0441941731F, 0.03125F, 0.0220970865F, 0.015625F, 0.0110485433F, 0.0078125F, 0.00552427163F, 0.00390625F, 0.00276213582F, 0.001953125F, 0.00138106791F, 0.0009765625F, 0.000690533954F, 0.00048828125F, 0.000345266977F, 0.000244140625F, 0.000172633489F, 0.000122070313F, 0.0000863167443F, 0.0000610351563F, 0.0000431583721F, 0.0000305175781F, 0.0000215791861F}}
    Private m_TAN12() As Single = {0.0F, 0.2679492F, 0.577350259F, 1.0F, 1.73205078F, 3.732051F, 1.0E+11F, -3.732051F, -1.73205078F, -1.0F, -0.577350259F, -0.2679492F, 0.0F, 0.2679492F, 0.577350259F, 1.0F}
    Private m_cs() As Single = {0.8574929F, 0.881742F, 0.949628651F, 0.9833146F, 0.9955178F, 0.9991606F, 0.9998992F, 0.999993145F}
    Private m_ca() As Single = {-0.51449573F, -0.471731961F, -0.31337744F, -0.1819132F, -0.09457419F, -0.0409655832F, -0.0141985686F, -0.00369997462F}
    Private m_win As Single()() = { _
        New Single() {-0.0161412153F, -0.05360318F, -0.100707136F, -0.16280818F, -0.5F, -0.383887351F, -0.6206114F, -1.16597557F, -3.87207532F, -4.225629F, -1.519529F, -0.974164844F, -0.737440765F, -1.20710683F, -0.5163616F, -0.454260528F, -0.407156557F, -0.3696946F, -0.3387627F, -0.312422216F, -0.289395869F, -0.268800825F, -0.5F, -0.232514173F, -0.215967149F, -0.200049788F, -0.184494928F, -0.169058457F, -0.153503612F, -0.137586251F, -0.121039219F, -0.207106784F, -0.0847525746F, -0.06415752F, -0.0411311723F, -0.0147907054F}, _
        New Single() {-0.0161412153F, -0.05360318F, -0.100707136F, -0.16280818F, -0.5F, -0.383887351F, -0.6206114F, -1.16597557F, -3.87207532F, -4.225629F, -1.519529F, -0.974164844F, -0.737440765F, -1.20710683F, -0.5163616F, -0.454260528F, -0.407156557F, -0.3696946F, -0.33908543F, -0.3151181F, -0.296422273F, -0.28184548F, -0.5411961F, -0.2621323F, -0.25387916F, -0.2329629F, -0.198527291F, -0.152335346F, -0.0964964F, -0.03342383F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, _
        New Single() {-0.0483008F, -0.157156572F, -0.283250451F, -0.429537475F, -1.20710683F, -0.8242648F, -1.14517486F, -1.769529F, -4.54702234F, -3.489053F, -0.7329629F, -0.150765151F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F}, _
        New Single() {0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, -0.150765136F, -0.7329629F, -3.489053F, -4.54702234F, -1.769529F, -1.14517486F, -0.8313774F, -1.306563F, -0.541420162F, -0.465289742F, -0.4106699F, -0.3700468F, -0.3387627F, -0.312422216F, -0.289395869F, -0.268800825F, -0.5F, -0.232514173F, -0.215967149F, -0.200049788F, -0.184494928F, -0.169058457F, -0.153503612F, -0.137586251F, -0.121039219F, -0.207106784F, -0.0847525746F, -0.06415752F, -0.0411311723F, -0.0147907054F} _
        }
    Private m_nr_of_sfb_block As Integer()()() = {New Integer()() {New Integer() {6, 5, 5, 5}, New Integer() {9, 9, 9, 9}, New Integer() {6, 9, 9, 9}}, New Integer()() {New Integer() {6, 5, 7, 3}, New Integer() {9, 9, 12, 6}, New Integer() {6, 9, 12, 6}}, New Integer()() {New Integer() {11, 10, 0, 0}, New Integer() {18, 18, 0, 0}, New Integer() {15, 18, 0, 0}}, New Integer()() {New Integer() {7, 7, 7, 0}, New Integer() {12, 12, 12, 0}, New Integer() {6, 15, 12, 0}}, New Integer()() {New Integer() {6, 6, 6, 3}, New Integer() {12, 9, 9, 6}, New Integer() {6, 12, 9, 6}}, New Integer()() {New Integer() {8, 8, 5, 0}, New Integer() {15, 12, 9, 0}, New Integer() {6, 18, 9, 0}}}

#End Region

End Class