' Base Class for audio output
Public MustInherit Class AudioOutputBuffer

#Region " Functions "
    ' takes a 16 Bit PCM sample
    Public MustOverride Sub Append(ByVal channel As Integer, ByVal value_Renamed As Short)

    ' Write the samples to the file or directly to the audio hardware
    Public MustOverride Sub WriteBuffer(ByVal val As Integer)

    ' Clears all data in the buffer (for seeking)
    Public MustOverride Sub ClearBuffer()

    ' accepts 32 new PCM samples
    Public Overridable Sub AppendSamples(ByVal channel As Integer, ByVal f() As Single)
        Dim i As Integer
        While i < 32
            Append(channel, Clip(f(i)))
            i += 1
        End While
    End Sub

    ' Clip Sample to 16 Bits
    Private Function Clip(ByVal sample As Single) As Short
        If sample > 32767.0F Then
            Return 32767
        ElseIf sample < -32768.0F Then
            Return -32768
        Else
            Return Fix(sample)
        End If
    End Function
#End Region

End Class