' ByteBuffer for the BackStream
Public Class CircularByteBuffer

#Region " Private Variables "
    Private m_dataArray As Byte()
    Private m_length As Integer = 1
    Private m_index As Integer
    Private m_numValid As Integer
#End Region

#Region " Constructor "
    Public Sub New(ByVal size As Integer)
        ReDim m_dataArray(size - 1)
        m_length = size
    End Sub
#End Region

#Region " Functions "

    ' Push a byte into the buffer. Returns the value of whatever comes off.
    Public Function Push(ByVal newValue As Byte) As Byte
        Dim ret As Byte
        SyncLock Me
            ret = InternalGet(m_length)
            m_dataArray(m_index) = newValue
            m_numValid += 1
            If m_numValid > m_length Then
                m_numValid = m_length
            End If
            m_index += 1
            m_index = m_index Mod m_length
        End SyncLock
        Return ret
    End Function

    Public Function GetByte(ByVal index As Integer) As Byte
        Return InternalGet((-1 - index))
    End Function

    Private Function InternalGet(ByVal offset As Integer) As Byte
        Dim ind As Integer = m_index + offset

        While ind >= m_length
            ind -= m_length
        End While

        While ind < 0
            ind += m_length
        End While
        Return m_dataArray(ind)

    End Function

#End Region

End Class

