' Class with an array of huffcode tables
' to implement Huffman decoder.
Public Class HuffcodeTableArray

    ' array of all huffcodtable headers
    ' 0..31 Huffman code table 0..31
    ' 32, 33 count1-tables
    Public Tables(33) As HuffcodeTable

    ' Constructor
    Public Sub New()
        Tables(0) = New HuffcodeTable("0  ", 0, 0, 0, ValTab(0), 0)
        Tables(1) = New HuffcodeTable("1  ", 2, 2, 0, ValTab(1), 7)
        Tables(2) = New HuffcodeTable("2  ", 3, 3, 0, ValTab(2), 17)
        Tables(3) = New HuffcodeTable("3  ", 3, 3, 0, ValTab(3), 17)
        Tables(4) = New HuffcodeTable("4  ", 0, 0, 0, ValTab(4), 0)
        Tables(5) = New HuffcodeTable("5  ", 4, 4, 0, ValTab(5), 31)
        Tables(6) = New HuffcodeTable("6  ", 4, 4, 0, ValTab(6), 31)
        Tables(7) = New HuffcodeTable("7  ", 6, 6, 0, ValTab(7), 71)
        Tables(8) = New HuffcodeTable("8  ", 6, 6, 0, ValTab(8), 71)
        Tables(9) = New HuffcodeTable("9  ", 6, 6, 0, ValTab(9), 71)
        Tables(10) = New HuffcodeTable("10 ", 8, 8, 0, ValTab(10), 127)
        Tables(11) = New HuffcodeTable("11 ", 8, 8, 0, ValTab(11), 127)
        Tables(12) = New HuffcodeTable("12 ", 8, 8, 0, ValTab(12), 127)
        Tables(13) = New HuffcodeTable("13 ", 16, 16, 0, ValTab(13), 511)
        Tables(14) = New HuffcodeTable("14 ", 0, 0, 0, ValTab(14), 0)
        Tables(15) = New HuffcodeTable("15 ", 16, 16, 0, ValTab(15), 511)
        Tables(16) = New HuffcodeTable("16 ", 16, 16, 1, ValTab(16), 511)
        Tables(17) = New HuffcodeTable("17 ", 16, 16, 2, ValTab(16), 511)
        Tables(18) = New HuffcodeTable("18 ", 16, 16, 3, ValTab(16), 511)
        Tables(19) = New HuffcodeTable("19 ", 16, 16, 4, ValTab(16), 511)
        Tables(20) = New HuffcodeTable("20 ", 16, 16, 6, ValTab(16), 511)
        Tables(21) = New HuffcodeTable("21 ", 16, 16, 8, ValTab(16), 511)
        Tables(22) = New HuffcodeTable("22 ", 16, 16, 10, ValTab(16), 511)
        Tables(23) = New HuffcodeTable("23 ", 16, 16, 13, ValTab(16), 511)
        Tables(24) = New HuffcodeTable("24 ", 16, 16, 4, ValTab(24), 512)
        Tables(25) = New HuffcodeTable("25 ", 16, 16, 5, ValTab(24), 512)
        Tables(26) = New HuffcodeTable("26 ", 16, 16, 6, ValTab(24), 512)
        Tables(27) = New HuffcodeTable("27 ", 16, 16, 7, ValTab(24), 512)
        Tables(28) = New HuffcodeTable("28 ", 16, 16, 8, ValTab(24), 512)
        Tables(29) = New HuffcodeTable("29 ", 16, 16, 9, ValTab(24), 512)
        Tables(30) = New HuffcodeTable("30 ", 16, 16, 11, ValTab(24), 512)
        Tables(31) = New HuffcodeTable("31 ", 16, 16, 13, ValTab(24), 512)
        Tables(32) = New HuffcodeTable("32 ", 1, 16, 0, ValTab(32), 31)
        Tables(33) = New HuffcodeTable("33 ", 1, 16, 0, ValTab(33), 31)
    End Sub

    ' Returns value tables for the huffcode tables
    Private Function ValTab(ByVal TabIndex As Integer) As Integer()()
        Select Case TabIndex
            Case 0 : Return New Integer()() {New Integer() {0, 0}}
            Case 1 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 17}}
            Case 2 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 33}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 2}, New Integer() {0, 34}}
            Case 3 : Return New Integer()() {New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 33}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 2}, New Integer() {0, 34}}
            Case 4 : Return New Integer()() {New Integer() {0, 0}}
            Case 5 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {0, 48}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 19}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {2, 1}, New Integer() {0, 35}, New Integer() {0, 51}}
            Case 6 : Return New Integer()() {New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {0, 16}, New Integer() {0, 17}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 33}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 2}, New Integer() {0, 34}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 50}, New Integer() {2, 1}, New Integer() {0, 35}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 51}}
            Case 7 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {0, 33}, New Integer() {18, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {0, 48}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 50}, New Integer() {2, 1}, New Integer() {0, 35}, New Integer() {0, 4}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 65}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {2, 1}, New Integer() {0, 66}, New Integer() {0, 36}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 67}, New Integer() {0, 80}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 52}, New Integer() {0, 5}, New Integer() {0, 81}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 21}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 53}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 83}, New Integer() {0, 84}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {0, 85}}
            Case 8 : Return New Integer()() {New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {14, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 3}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 4}, New Integer() {2, 1}, New Integer() {0, 65}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {0, 66}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 36}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 80}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {0, 81}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 21}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 82}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 37}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 53}, New Integer() {2, 1}, New Integer() {0, 83}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {2, 1}, New Integer() {0, 84}, New Integer() {0, 85}}
            Case 9 : Return New Integer()() {New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {0, 16}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 17}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 33}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 2}, New Integer() {0, 34}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 3}, New Integer() {0, 49}, New Integer() {2, 1}, New Integer() {0, 19}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 65}, New Integer() {0, 20}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 51}, New Integer() {2, 1}, New Integer() {0, 66}, New Integer() {0, 36}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 4}, New Integer() {0, 80}, New Integer() {0, 67}, New Integer() {2, 1}, New Integer() {0, 52}, New Integer() {0, 81}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 21}, New Integer() {0, 82}, New Integer() {2, 1}, New Integer() {0, 37}, New Integer() {0, 68}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 84}, New Integer() {0, 83}, New Integer() {2, 1}, New Integer() {0, 53}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {0, 85}}
            Case 10 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {10, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {28, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {0, 48}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 50}, New Integer() {2, 1}, New Integer() {0, 35}, New Integer() {0, 64}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 65}, New Integer() {0, 20}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 4}, New Integer() {0, 51}, New Integer() {2, 1}, New Integer() {0, 66}, New Integer() {0, 36}, New Integer() {28, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 80}, New Integer() {0, 5}, New Integer() {0, 96}, New Integer() {2, 1}, New Integer() {0, 97}, New Integer() {0, 22}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {0, 81}, New Integer() {2, 1}, New Integer() {0, 21}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 38}, New Integer() {0, 54}, New Integer() {0, 113}, New Integer() {20, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 23}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 83}, New Integer() {0, 6}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 53}, New Integer() {0, 69}, New Integer() {0, 98}, New Integer() {2, 1}, New Integer() {0, 112}, New Integer() {2, 1}, New Integer() {0, 7}, New Integer() {0, 100}, New Integer() {14, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 114}, New Integer() {0, 39}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 99}, New Integer() {2, 1}, New Integer() {0, 84}, New Integer() {0, 85}, New Integer() {2, 1}, New Integer() {0, 70}, New Integer() {0, 115}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 55}, New Integer() {0, 101}, New Integer() {2, 1}, New Integer() {0, 86}, New Integer() {0, 116}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 71}, New Integer() {2, 1}, New Integer() {0, 102}, New Integer() {0, 117}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 87}, New Integer() {0, 118}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 119}}
            Case 11 : Return New Integer()() {New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {0, 18}, New Integer() {24, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 3}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 4}, New Integer() {2, 1}, New Integer() {0, 65}, New Integer() {0, 20}, New Integer() {30, 1}, New Integer() {16, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 66}, New Integer() {0, 36}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 67}, New Integer() {0, 80}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 52}, New Integer() {0, 81}, New Integer() {0, 97}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 22}, New Integer() {2, 1}, New Integer() {0, 6}, New Integer() {0, 38}, New Integer() {2, 1}, New Integer() {0, 98}, New Integer() {2, 1}, New Integer() {0, 21}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 82}, New Integer() {16, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 37}, New Integer() {0, 68}, New Integer() {0, 96}, New Integer() {2, 1}, New Integer() {0, 99}, New Integer() {0, 54}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 112}, New Integer() {0, 23}, New Integer() {0, 113}, New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 7}, New Integer() {0, 100}, New Integer() {0, 114}, New Integer() {2, 1}, New Integer() {0, 39}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 83}, New Integer() {0, 53}, New Integer() {2, 1}, New Integer() {0, 84}, New Integer() {0, 69}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 70}, New Integer() {0, 115}, New Integer() {2, 1}, New Integer() {0, 55}, New Integer() {2, 1}, New Integer() {0, 101}, New Integer() {0, 86}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 85}, New Integer() {0, 87}, New Integer() {0, 116}, New Integer() {2, 1}, New Integer() {0, 71}, New Integer() {0, 102}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 118}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 119}}
            Case 12 : Return New Integer()() {New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {16, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {0, 49}, New Integer() {2, 1}, New Integer() {0, 19}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 64}, New Integer() {26, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {2, 1}, New Integer() {0, 65}, New Integer() {0, 51}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {0, 66}, New Integer() {2, 1}, New Integer() {0, 36}, New Integer() {2, 1}, New Integer() {0, 4}, New Integer() {0, 80}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {2, 1}, New Integer() {0, 81}, New Integer() {0, 21}, New Integer() {28, 1}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {2, 1}, New Integer() {0, 83}, New Integer() {0, 53}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 96}, New Integer() {0, 22}, New Integer() {0, 97}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 98}, New Integer() {0, 38}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 6}, New Integer() {0, 68}, New Integer() {2, 1}, New Integer() {0, 84}, New Integer() {0, 69}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 99}, New Integer() {0, 54}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 112}, New Integer() {0, 7}, New Integer() {0, 113}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 23}, New Integer() {0, 100}, New Integer() {2, 1}, New Integer() {0, 70}, New Integer() {0, 114}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 39}, New Integer() {2, 1}, New Integer() {0, 85}, New Integer() {0, 115}, New Integer() {2, 1}, New Integer() {0, 55}, New Integer() {0, 86}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 101}, New Integer() {0, 116}, New Integer() {2, 1}, New Integer() {0, 71}, New Integer() {0, 102}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 87}, New Integer() {2, 1}, New Integer() {0, 118}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 119}}
            Case 13 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 17}, New Integer() {28, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {0, 48}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 49}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 19}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 4}, New Integer() {0, 65}, New Integer() {70, 1}, New Integer() {28, 1}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 66}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 36}, New Integer() {0, 80}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 81}, New Integer() {0, 21}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 82}, New Integer() {2, 1}, New Integer() {0, 37}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 83}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 96}, New Integer() {0, 6}, New Integer() {2, 1}, New Integer() {0, 97}, New Integer() {0, 22}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 128}, New Integer() {0, 8}, New Integer() {0, 129}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 53}, New Integer() {0, 98}, New Integer() {2, 1}, New Integer() {0, 38}, New Integer() {0, 84}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {0, 99}, New Integer() {2, 1}, New Integer() {0, 54}, New Integer() {0, 112}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 7}, New Integer() {0, 85}, New Integer() {0, 113}, New Integer() {2, 1}, New Integer() {0, 23}, New Integer() {2, 1}, New Integer() {0, 39}, New Integer() {0, 55}, New Integer() {72, 1}, New Integer() {24, 1}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 24}, New Integer() {0, 130}, New Integer() {2, 1}, New Integer() {0, 40}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 100}, New Integer() {0, 70}, New Integer() {0, 114}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 132}, New Integer() {0, 72}, New Integer() {2, 1}, New Integer() {0, 144}, New Integer() {0, 9}, New Integer() {2, 1}, New Integer() {0, 145}, New Integer() {0, 25}, New Integer() {24, 1}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 115}, New Integer() {0, 101}, New Integer() {2, 1}, New Integer() {0, 86}, New Integer() {0, 116}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 71}, New Integer() {0, 102}, New Integer() {0, 131}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 56}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 87}, New Integer() {2, 1}, New Integer() {0, 146}, New Integer() {0, 41}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 133}, New Integer() {2, 1}, New Integer() {0, 88}, New Integer() {0, 57}, New Integer() {2, 1}, New Integer() {0, 147}, New Integer() {2, 1}, New Integer() {0, 73}, New Integer() {0, 134}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 160}, New Integer() {2, 1}, New Integer() {0, 104}, New Integer() {0, 10}, New Integer() {2, 1}, New Integer() {0, 161}, New Integer() {0, 26}, New Integer() {68, 1}, New Integer() {24, 1}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 162}, New Integer() {0, 42}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 149}, New Integer() {0, 89}, New Integer() {2, 1}, New Integer() {0, 163}, New Integer() {0, 58}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 74}, New Integer() {0, 150}, New Integer() {2, 1}, New Integer() {0, 176}, New Integer() {0, 11}, New Integer() {2, 1}, New Integer() {0, 177}, New Integer() {0, 27}, New Integer() {20, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 178}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 118}, New Integer() {0, 119}, New Integer() {0, 148}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 135}, New Integer() {0, 120}, New Integer() {0, 164}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 105}, New Integer() {0, 165}, New Integer() {0, 43}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 90}, New Integer() {0, 136}, New Integer() {0, 179}, New Integer() {2, 1}, New Integer() {0, 59}, New Integer() {2, 1}, New Integer() {0, 121}, New Integer() {0, 166}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 106}, New Integer() {0, 180}, New Integer() {0, 192}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 152}, New Integer() {0, 193}, New Integer() {60, 1}, New Integer() {22, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 28}, New Integer() {2, 1}, New Integer() {0, 137}, New Integer() {0, 181}, New Integer() {2, 1}, New Integer() {0, 91}, New Integer() {0, 194}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 44}, New Integer() {0, 60}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 182}, New Integer() {0, 107}, New Integer() {2, 1}, New Integer() {0, 196}, New Integer() {0, 76}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 168}, New Integer() {0, 138}, New Integer() {2, 1}, New Integer() {0, 208}, New Integer() {0, 13}, New Integer() {2, 1}, New Integer() {0, 209}, New Integer() {2, 1}, New Integer() {0, 75}, New Integer() {2, 1}, New Integer() {0, 151}, New Integer() {0, 167}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 195}, New Integer() {2, 1}, New Integer() {0, 122}, New Integer() {0, 153}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 197}, New Integer() {0, 92}, New Integer() {0, 183}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 29}, New Integer() {0, 210}, New Integer() {2, 1}, New Integer() {0, 45}, New Integer() {2, 1}, New Integer() {0, 123}, New Integer() {0, 211}, New Integer() {52, 1}, New Integer() {28, 1}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 61}, New Integer() {0, 198}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 108}, New Integer() {0, 169}, New Integer() {2, 1}, New Integer() {0, 154}, New Integer() {0, 212}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 184}, New Integer() {0, 139}, New Integer() {2, 1}, New Integer() {0, 77}, New Integer() {0, 199}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 124}, New Integer() {0, 213}, New Integer() {2, 1}, New Integer() {0, 93}, New Integer() {0, 224}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 225}, New Integer() {0, 30}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 14}, New Integer() {0, 46}, New Integer() {0, 226}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 227}, New Integer() {0, 109}, New Integer() {2, 1}, New Integer() {0, 140}, New Integer() {0, 228}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 229}, New Integer() {0, 186}, New Integer() {0, 240}, New Integer() {38, 1}, New Integer() {16, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 241}, New Integer() {0, 31}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 170}, New Integer() {0, 155}, New Integer() {0, 185}, New Integer() {2, 1}, New Integer() {0, 62}, New Integer() {2, 1}, New Integer() {0, 214}, New Integer() {0, 200}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 78}, New Integer() {2, 1}, New Integer() {0, 215}, New Integer() {0, 125}, New Integer() {2, 1}, New Integer() {0, 171}, New Integer() {2, 1}, New Integer() {0, 94}, New Integer() {0, 201}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 15}, New Integer() {2, 1}, New Integer() {0, 156}, New Integer() {0, 110}, New Integer() {2, 1}, New Integer() {0, 242}, New Integer() {0, 47}, New Integer() {32, 1}, New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 216}, New Integer() {0, 141}, New Integer() {0, 63}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 243}, New Integer() {2, 1}, New Integer() {0, 230}, New Integer() {0, 202}, New Integer() {2, 1}, New Integer() {0, 244}, New Integer() {0, 79}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 187}, New Integer() {0, 172}, New Integer() {2, 1}, New Integer() {0, 231}, New Integer() {0, 245}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 217}, New Integer() {0, 157}, New Integer() {2, 1}, New Integer() {0, 95}, New Integer() {0, 232}, New Integer() {30, 1}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 111}, New Integer() {2, 1}, New Integer() {0, 246}, New Integer() {0, 203}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 188}, New Integer() {0, 173}, New Integer() {0, 218}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 247}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 126}, New Integer() {0, 127}, New Integer() {0, 142}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 158}, New Integer() {0, 174}, New Integer() {0, 204}, New Integer() {2, 1}, New Integer() {0, 248}, New Integer() {0, 143}, New Integer() {18, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 219}, New Integer() {0, 189}, New Integer() {2, 1}, New Integer() {0, 234}, New Integer() {0, 249}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 159}, New Integer() {0, 235}, New Integer() {2, 1}, New Integer() {0, 190}, New Integer() {2, 1}, New Integer() {0, 205}, New Integer() {0, 250}, New Integer() {14, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 221}, New Integer() {0, 236}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 233}, New Integer() {0, 175}, New Integer() {0, 220}, New Integer() {2, 1}, New Integer() {0, 206}, New Integer() {0, 251}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 191}, New Integer() {0, 222}, New Integer() {2, 1}, New Integer() {0, 207}, New Integer() {0, 238}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 223}, New Integer() {0, 239}, New Integer() {2, 1}, New Integer() {0, 255}, New Integer() {2, 1}, New Integer() {0, 237}, New Integer() {2, 1}, New Integer() {0, 253}, New Integer() {2, 1}, New Integer() {0, 252}, New Integer() {0, 254}}
            Case 14 : Return New Integer()() {New Integer() {0, 0}}
            Case 15 : Return New Integer()() {New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 17}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {50, 1}, New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 49}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 19}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 64}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 4}, New Integer() {0, 20}, New Integer() {0, 65}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 66}, New Integer() {2, 1}, New Integer() {0, 36}, New Integer() {0, 67}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 52}, New Integer() {2, 1}, New Integer() {0, 80}, New Integer() {0, 5}, New Integer() {2, 1}, New Integer() {0, 81}, New Integer() {0, 21}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 83}, New Integer() {0, 97}, New Integer() {90, 1}, New Integer() {36, 1}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 53}, New Integer() {2, 1}, New Integer() {0, 96}, New Integer() {0, 6}, New Integer() {2, 1}, New Integer() {0, 22}, New Integer() {0, 98}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 38}, New Integer() {0, 84}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {0, 99}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 54}, New Integer() {2, 1}, New Integer() {0, 112}, New Integer() {0, 7}, New Integer() {2, 1}, New Integer() {0, 113}, New Integer() {0, 85}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 23}, New Integer() {0, 100}, New Integer() {2, 1}, New Integer() {0, 114}, New Integer() {0, 39}, New Integer() {24, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 70}, New Integer() {0, 115}, New Integer() {2, 1}, New Integer() {0, 55}, New Integer() {0, 101}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 86}, New Integer() {0, 128}, New Integer() {2, 1}, New Integer() {0, 8}, New Integer() {0, 116}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 129}, New Integer() {0, 24}, New Integer() {2, 1}, New Integer() {0, 130}, New Integer() {0, 40}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 71}, New Integer() {0, 102}, New Integer() {2, 1}, New Integer() {0, 131}, New Integer() {0, 56}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 87}, New Integer() {2, 1}, New Integer() {0, 132}, New Integer() {0, 72}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 144}, New Integer() {0, 25}, New Integer() {0, 145}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 146}, New Integer() {0, 118}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 41}, New Integer() {92, 1}, New Integer() {36, 1}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 133}, New Integer() {0, 88}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 9}, New Integer() {0, 119}, New Integer() {0, 147}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 57}, New Integer() {0, 148}, New Integer() {2, 1}, New Integer() {0, 73}, New Integer() {0, 134}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 104}, New Integer() {2, 1}, New Integer() {0, 160}, New Integer() {0, 10}, New Integer() {2, 1}, New Integer() {0, 161}, New Integer() {0, 26}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 162}, New Integer() {0, 42}, New Integer() {2, 1}, New Integer() {0, 149}, New Integer() {0, 89}, New Integer() {26, 1}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 163}, New Integer() {2, 1}, New Integer() {0, 58}, New Integer() {0, 135}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 120}, New Integer() {0, 164}, New Integer() {2, 1}, New Integer() {0, 74}, New Integer() {0, 150}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 105}, New Integer() {0, 176}, New Integer() {0, 177}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 27}, New Integer() {0, 165}, New Integer() {0, 178}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 90}, New Integer() {0, 43}, New Integer() {2, 1}, New Integer() {0, 136}, New Integer() {0, 151}, New Integer() {2, 1}, New Integer() {0, 179}, New Integer() {2, 1}, New Integer() {0, 121}, New Integer() {0, 59}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 106}, New Integer() {0, 180}, New Integer() {2, 1}, New Integer() {0, 75}, New Integer() {0, 193}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 152}, New Integer() {0, 137}, New Integer() {2, 1}, New Integer() {0, 28}, New Integer() {0, 181}, New Integer() {80, 1}, New Integer() {34, 1}, New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 91}, New Integer() {0, 44}, New Integer() {0, 194}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 11}, New Integer() {0, 192}, New Integer() {0, 166}, New Integer() {2, 1}, New Integer() {0, 167}, New Integer() {0, 122}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 195}, New Integer() {0, 60}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 153}, New Integer() {0, 182}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 107}, New Integer() {0, 196}, New Integer() {2, 1}, New Integer() {0, 76}, New Integer() {0, 168}, New Integer() {20, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 138}, New Integer() {0, 197}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 208}, New Integer() {0, 92}, New Integer() {0, 209}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 183}, New Integer() {0, 123}, New Integer() {2, 1}, New Integer() {0, 29}, New Integer() {2, 1}, New Integer() {0, 13}, New Integer() {0, 45}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 210}, New Integer() {0, 211}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 61}, New Integer() {0, 198}, New Integer() {2, 1}, New Integer() {0, 108}, New Integer() {0, 169}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 154}, New Integer() {0, 184}, New Integer() {0, 212}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 139}, New Integer() {0, 77}, New Integer() {2, 1}, New Integer() {0, 199}, New Integer() {0, 124}, New Integer() {68, 1}, New Integer() {34, 1}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 213}, New Integer() {0, 93}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 224}, New Integer() {0, 14}, New Integer() {0, 225}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 30}, New Integer() {0, 226}, New Integer() {2, 1}, New Integer() {0, 170}, New Integer() {0, 46}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 185}, New Integer() {0, 155}, New Integer() {2, 1}, New Integer() {0, 227}, New Integer() {0, 214}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 109}, New Integer() {0, 62}, New Integer() {2, 1}, New Integer() {0, 200}, New Integer() {0, 140}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 228}, New Integer() {0, 78}, New Integer() {2, 1}, New Integer() {0, 215}, New Integer() {0, 125}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 229}, New Integer() {0, 186}, New Integer() {2, 1}, New Integer() {0, 171}, New Integer() {0, 94}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 201}, New Integer() {0, 156}, New Integer() {2, 1}, New Integer() {0, 241}, New Integer() {0, 31}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 240}, New Integer() {0, 110}, New Integer() {0, 242}, New Integer() {2, 1}, New Integer() {0, 47}, New Integer() {0, 230}, New Integer() {38, 1}, New Integer() {18, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 216}, New Integer() {0, 243}, New Integer() {2, 1}, New Integer() {0, 63}, New Integer() {0, 244}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 79}, New Integer() {2, 1}, New Integer() {0, 141}, New Integer() {0, 217}, New Integer() {2, 1}, New Integer() {0, 187}, New Integer() {0, 202}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 172}, New Integer() {0, 231}, New Integer() {2, 1}, New Integer() {0, 126}, New Integer() {0, 245}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 157}, New Integer() {0, 95}, New Integer() {2, 1}, New Integer() {0, 232}, New Integer() {0, 142}, New Integer() {2, 1}, New Integer() {0, 246}, New Integer() {0, 203}, New Integer() {34, 1}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 15}, New Integer() {0, 174}, New Integer() {0, 111}, New Integer() {2, 1}, New Integer() {0, 188}, New Integer() {0, 218}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 173}, New Integer() {0, 247}, New Integer() {2, 1}, New Integer() {0, 127}, New Integer() {0, 233}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 158}, New Integer() {0, 204}, New Integer() {2, 1}, New Integer() {0, 248}, New Integer() {0, 143}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 219}, New Integer() {0, 189}, New Integer() {2, 1}, New Integer() {0, 234}, New Integer() {0, 249}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 159}, New Integer() {0, 220}, New Integer() {2, 1}, New Integer() {0, 205}, New Integer() {0, 235}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 190}, New Integer() {0, 250}, New Integer() {2, 1}, New Integer() {0, 175}, New Integer() {0, 221}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 236}, New Integer() {0, 206}, New Integer() {0, 251}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 191}, New Integer() {0, 237}, New Integer() {2, 1}, New Integer() {0, 222}, New Integer() {0, 252}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 207}, New Integer() {0, 253}, New Integer() {0, 238}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 223}, New Integer() {0, 254}, New Integer() {2, 1}, New Integer() {0, 239}, New Integer() {0, 255}}
            Case 16 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 16}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 17}, New Integer() {42, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {2, 1}, New Integer() {0, 33}, New Integer() {0, 18}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 3}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 4}, New Integer() {0, 65}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {2, 1}, New Integer() {0, 51}, New Integer() {0, 66}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 36}, New Integer() {0, 80}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {138, 1}, New Integer() {40, 1}, New Integer() {16, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 21}, New Integer() {0, 81}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 53}, New Integer() {0, 83}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 96}, New Integer() {0, 6}, New Integer() {0, 97}, New Integer() {2, 1}, New Integer() {0, 22}, New Integer() {0, 98}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 38}, New Integer() {0, 84}, New Integer() {2, 1}, New Integer() {0, 69}, New Integer() {0, 99}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 54}, New Integer() {0, 112}, New Integer() {0, 113}, New Integer() {40, 1}, New Integer() {18, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 23}, New Integer() {2, 1}, New Integer() {0, 7}, New Integer() {2, 1}, New Integer() {0, 85}, New Integer() {0, 100}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 114}, New Integer() {0, 39}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 70}, New Integer() {0, 101}, New Integer() {0, 115}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 55}, New Integer() {2, 1}, New Integer() {0, 86}, New Integer() {0, 8}, New Integer() {2, 1}, New Integer() {0, 128}, New Integer() {0, 129}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 24}, New Integer() {2, 1}, New Integer() {0, 116}, New Integer() {0, 71}, New Integer() {2, 1}, New Integer() {0, 130}, New Integer() {2, 1}, New Integer() {0, 40}, New Integer() {0, 102}, New Integer() {24, 1}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 131}, New Integer() {0, 56}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 132}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 72}, New Integer() {0, 144}, New Integer() {0, 145}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 25}, New Integer() {2, 1}, New Integer() {0, 9}, New Integer() {0, 118}, New Integer() {2, 1}, New Integer() {0, 146}, New Integer() {0, 41}, New Integer() {14, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 133}, New Integer() {0, 88}, New Integer() {2, 1}, New Integer() {0, 147}, New Integer() {0, 57}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 160}, New Integer() {0, 10}, New Integer() {0, 26}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 162}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {2, 1}, New Integer() {0, 87}, New Integer() {0, 73}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 148}, New Integer() {2, 1}, New Integer() {0, 119}, New Integer() {0, 134}, New Integer() {2, 1}, New Integer() {0, 161}, New Integer() {2, 1}, New Integer() {0, 104}, New Integer() {0, 149}, New Integer() {220, 1}, New Integer() {126, 1}, New Integer() {50, 1}, New Integer() {26, 1}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 42}, New Integer() {2, 1}, New Integer() {0, 89}, New Integer() {0, 58}, New Integer() {2, 1}, New Integer() {0, 163}, New Integer() {2, 1}, New Integer() {0, 135}, New Integer() {0, 120}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 164}, New Integer() {0, 74}, New Integer() {2, 1}, New Integer() {0, 150}, New Integer() {0, 105}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 176}, New Integer() {0, 11}, New Integer() {0, 177}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 27}, New Integer() {0, 178}, New Integer() {2, 1}, New Integer() {0, 43}, New Integer() {2, 1}, New Integer() {0, 165}, New Integer() {0, 90}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 179}, New Integer() {2, 1}, New Integer() {0, 166}, New Integer() {0, 106}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 180}, New Integer() {0, 75}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 193}, New Integer() {30, 1}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 181}, New Integer() {0, 194}, New Integer() {0, 44}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 167}, New Integer() {0, 195}, New Integer() {2, 1}, New Integer() {0, 107}, New Integer() {0, 196}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 29}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 136}, New Integer() {0, 151}, New Integer() {0, 59}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 209}, New Integer() {0, 210}, New Integer() {2, 1}, New Integer() {0, 45}, New Integer() {0, 211}, New Integer() {18, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 30}, New Integer() {0, 46}, New Integer() {0, 226}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 121}, New Integer() {0, 152}, New Integer() {0, 192}, New Integer() {2, 1}, New Integer() {0, 28}, New Integer() {2, 1}, New Integer() {0, 137}, New Integer() {0, 91}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 60}, New Integer() {2, 1}, New Integer() {0, 122}, New Integer() {0, 182}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 76}, New Integer() {0, 153}, New Integer() {2, 1}, New Integer() {0, 168}, New Integer() {0, 138}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 13}, New Integer() {2, 1}, New Integer() {0, 197}, New Integer() {0, 92}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 61}, New Integer() {0, 198}, New Integer() {2, 1}, New Integer() {0, 108}, New Integer() {0, 154}, New Integer() {88, 1}, New Integer() {86, 1}, New Integer() {36, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 139}, New Integer() {0, 77}, New Integer() {2, 1}, New Integer() {0, 199}, New Integer() {0, 124}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 213}, New Integer() {0, 93}, New Integer() {2, 1}, New Integer() {0, 224}, New Integer() {0, 14}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 227}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 208}, New Integer() {0, 183}, New Integer() {0, 123}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 169}, New Integer() {0, 184}, New Integer() {0, 212}, New Integer() {2, 1}, New Integer() {0, 225}, New Integer() {2, 1}, New Integer() {0, 170}, New Integer() {0, 185}, New Integer() {24, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 155}, New Integer() {0, 214}, New Integer() {0, 109}, New Integer() {2, 1}, New Integer() {0, 62}, New Integer() {0, 200}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 140}, New Integer() {0, 228}, New Integer() {0, 78}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 215}, New Integer() {0, 229}, New Integer() {2, 1}, New Integer() {0, 186}, New Integer() {0, 171}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 156}, New Integer() {0, 230}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 110}, New Integer() {0, 216}, New Integer() {2, 1}, New Integer() {0, 141}, New Integer() {0, 187}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 231}, New Integer() {0, 157}, New Integer() {2, 1}, New Integer() {0, 232}, New Integer() {0, 142}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 203}, New Integer() {0, 188}, New Integer() {0, 158}, New Integer() {0, 241}, New Integer() {2, 1}, New Integer() {0, 31}, New Integer() {2, 1}, New Integer() {0, 15}, New Integer() {0, 47}, New Integer() {66, 1}, New Integer() {56, 1}, New Integer() {2, 1}, New Integer() {0, 242}, New Integer() {52, 1}, New Integer() {50, 1}, New Integer() {20, 1}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 189}, New Integer() {2, 1}, New Integer() {0, 94}, New Integer() {2, 1}, New Integer() {0, 125}, New Integer() {0, 201}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 202}, New Integer() {2, 1}, New Integer() {0, 172}, New Integer() {0, 126}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 218}, New Integer() {0, 173}, New Integer() {0, 204}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 174}, New Integer() {2, 1}, New Integer() {0, 219}, New Integer() {0, 220}, New Integer() {2, 1}, New Integer() {0, 205}, New Integer() {0, 190}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 235}, New Integer() {0, 237}, New Integer() {0, 238}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 217}, New Integer() {0, 234}, New Integer() {0, 233}, New Integer() {2, 1}, New Integer() {0, 222}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 221}, New Integer() {0, 236}, New Integer() {0, 206}, New Integer() {0, 63}, New Integer() {0, 240}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 243}, New Integer() {0, 244}, New Integer() {2, 1}, New Integer() {0, 79}, New Integer() {2, 1}, New Integer() {0, 245}, New Integer() {0, 95}, New Integer() {10, 1}, New Integer() {2, 1}, New Integer() {0, 255}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 246}, New Integer() {0, 111}, New Integer() {2, 1}, New Integer() {0, 247}, New Integer() {0, 127}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 143}, New Integer() {2, 1}, New Integer() {0, 248}, New Integer() {0, 249}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 159}, New Integer() {0, 250}, New Integer() {0, 175}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 251}, New Integer() {0, 191}, New Integer() {2, 1}, New Integer() {0, 252}, New Integer() {0, 207}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 253}, New Integer() {0, 223}, New Integer() {2, 1}, New Integer() {0, 254}, New Integer() {0, 239}}
            Case 24 : Return New Integer()() {New Integer() {60, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {0, 16}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 17}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 32}, New Integer() {0, 2}, New Integer() {0, 33}, New Integer() {2, 1}, New Integer() {0, 18}, New Integer() {2, 1}, New Integer() {0, 34}, New Integer() {2, 1}, New Integer() {0, 48}, New Integer() {0, 3}, New Integer() {14, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 49}, New Integer() {0, 19}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 50}, New Integer() {0, 35}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 64}, New Integer() {0, 4}, New Integer() {0, 65}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 20}, New Integer() {0, 51}, New Integer() {2, 1}, New Integer() {0, 66}, New Integer() {0, 36}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 67}, New Integer() {0, 52}, New Integer() {0, 81}, New Integer() {6, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 80}, New Integer() {0, 5}, New Integer() {0, 21}, New Integer() {2, 1}, New Integer() {0, 82}, New Integer() {0, 37}, New Integer() {250, 1}, New Integer() {98, 1}, New Integer() {34, 1}, New Integer() {18, 1}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 68}, New Integer() {0, 83}, New Integer() {2, 1}, New Integer() {0, 53}, New Integer() {2, 1}, New Integer() {0, 96}, New Integer() {0, 6}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 97}, New Integer() {0, 22}, New Integer() {2, 1}, New Integer() {0, 98}, New Integer() {0, 38}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 84}, New Integer() {0, 69}, New Integer() {2, 1}, New Integer() {0, 99}, New Integer() {0, 54}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 113}, New Integer() {0, 85}, New Integer() {2, 1}, New Integer() {0, 100}, New Integer() {0, 70}, New Integer() {32, 1}, New Integer() {14, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 114}, New Integer() {2, 1}, New Integer() {0, 39}, New Integer() {0, 55}, New Integer() {2, 1}, New Integer() {0, 115}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 112}, New Integer() {0, 7}, New Integer() {0, 23}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 101}, New Integer() {0, 86}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 128}, New Integer() {0, 8}, New Integer() {0, 129}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 116}, New Integer() {0, 71}, New Integer() {2, 1}, New Integer() {0, 24}, New Integer() {0, 130}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 40}, New Integer() {0, 102}, New Integer() {2, 1}, New Integer() {0, 131}, New Integer() {0, 56}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 117}, New Integer() {0, 87}, New Integer() {2, 1}, New Integer() {0, 132}, New Integer() {0, 72}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 145}, New Integer() {0, 25}, New Integer() {2, 1}, New Integer() {0, 146}, New Integer() {0, 118}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 103}, New Integer() {0, 41}, New Integer() {2, 1}, New Integer() {0, 133}, New Integer() {0, 88}, New Integer() {92, 1}, New Integer() {34, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 147}, New Integer() {0, 57}, New Integer() {2, 1}, New Integer() {0, 148}, New Integer() {0, 73}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 119}, New Integer() {0, 134}, New Integer() {2, 1}, New Integer() {0, 104}, New Integer() {0, 161}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 162}, New Integer() {0, 42}, New Integer() {2, 1}, New Integer() {0, 149}, New Integer() {0, 89}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 163}, New Integer() {0, 58}, New Integer() {2, 1}, New Integer() {0, 135}, New Integer() {2, 1}, New Integer() {0, 120}, New Integer() {0, 74}, New Integer() {22, 1}, New Integer() {12, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 164}, New Integer() {0, 150}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 105}, New Integer() {0, 177}, New Integer() {2, 1}, New Integer() {0, 27}, New Integer() {0, 165}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 178}, New Integer() {2, 1}, New Integer() {0, 90}, New Integer() {0, 43}, New Integer() {2, 1}, New Integer() {0, 136}, New Integer() {0, 179}, New Integer() {16, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 144}, New Integer() {2, 1}, New Integer() {0, 9}, New Integer() {0, 160}, New Integer() {2, 1}, New Integer() {0, 151}, New Integer() {0, 121}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 166}, New Integer() {0, 106}, New Integer() {0, 180}, New Integer() {12, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 26}, New Integer() {2, 1}, New Integer() {0, 10}, New Integer() {0, 176}, New Integer() {2, 1}, New Integer() {0, 59}, New Integer() {2, 1}, New Integer() {0, 11}, New Integer() {0, 192}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 75}, New Integer() {0, 193}, New Integer() {2, 1}, New Integer() {0, 152}, New Integer() {0, 137}, New Integer() {67, 1}, New Integer() {34, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 28}, New Integer() {0, 181}, New Integer() {2, 1}, New Integer() {0, 91}, New Integer() {0, 194}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 44}, New Integer() {0, 167}, New Integer() {2, 1}, New Integer() {0, 122}, New Integer() {0, 195}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 60}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 208}, New Integer() {2, 1}, New Integer() {0, 182}, New Integer() {0, 107}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 196}, New Integer() {0, 76}, New Integer() {2, 1}, New Integer() {0, 153}, New Integer() {0, 168}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 138}, New Integer() {0, 197}, New Integer() {2, 1}, New Integer() {0, 92}, New Integer() {0, 209}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 183}, New Integer() {0, 123}, New Integer() {2, 1}, New Integer() {0, 29}, New Integer() {0, 210}, New Integer() {9, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 45}, New Integer() {0, 211}, New Integer() {2, 1}, New Integer() {0, 61}, New Integer() {0, 198}, New Integer() {85, 250}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 108}, New Integer() {0, 169}, New Integer() {2, 1}, New Integer() {0, 154}, New Integer() {0, 212}, New Integer() {32, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 184}, New Integer() {0, 139}, New Integer() {2, 1}, New Integer() {0, 77}, New Integer() {0, 199}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 124}, New Integer() {0, 213}, New Integer() {2, 1}, New Integer() {0, 93}, New Integer() {0, 225}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 30}, New Integer() {0, 226}, New Integer() {2, 1}, New Integer() {0, 170}, New Integer() {0, 185}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 155}, New Integer() {0, 227}, New Integer() {2, 1}, New Integer() {0, 214}, New Integer() {0, 109}, New Integer() {20, 1}, New Integer() {10, 1}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 62}, New Integer() {2, 1}, New Integer() {0, 46}, New Integer() {0, 78}, New Integer() {2, 1}, New Integer() {0, 200}, New Integer() {0, 140}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 228}, New Integer() {0, 215}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 125}, New Integer() {0, 171}, New Integer() {0, 229}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 186}, New Integer() {0, 94}, New Integer() {2, 1}, New Integer() {0, 201}, New Integer() {2, 1}, New Integer() {0, 156}, New Integer() {0, 110}, New Integer() {8, 1}, New Integer() {2, 1}, New Integer() {0, 230}, New Integer() {2, 1}, New Integer() {0, 13}, New Integer() {2, 1}, New Integer() {0, 224}, New Integer() {0, 14}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 216}, New Integer() {0, 141}, New Integer() {2, 1}, New Integer() {0, 187}, New Integer() {0, 202}, New Integer() {74, 1}, New Integer() {2, 1}, New Integer() {0, 255}, New Integer() {64, 1}, New Integer() {58, 1}, New Integer() {32, 1}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 172}, New Integer() {0, 231}, New Integer() {2, 1}, New Integer() {0, 126}, New Integer() {0, 217}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 157}, New Integer() {0, 232}, New Integer() {2, 1}, New Integer() {0, 142}, New Integer() {0, 203}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 188}, New Integer() {0, 218}, New Integer() {2, 1}, New Integer() {0, 173}, New Integer() {0, 233}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 158}, New Integer() {0, 204}, New Integer() {2, 1}, New Integer() {0, 219}, New Integer() {0, 189}, New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 234}, New Integer() {0, 174}, New Integer() {2, 1}, New Integer() {0, 220}, New Integer() {0, 205}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 235}, New Integer() {0, 190}, New Integer() {2, 1}, New Integer() {0, 221}, New Integer() {0, 236}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 206}, New Integer() {0, 237}, New Integer() {2, 1}, New Integer() {0, 222}, New Integer() {0, 238}, New Integer() {0, 15}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 240}, New Integer() {0, 31}, New Integer() {0, 241}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 242}, New Integer() {0, 47}, New Integer() {2, 1}, New Integer() {0, 243}, New Integer() {0, 63}, New Integer() {18, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 244}, New Integer() {0, 79}, New Integer() {2, 1}, New Integer() {0, 245}, New Integer() {0, 95}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 246}, New Integer() {0, 111}, New Integer() {2, 1}, New Integer() {0, 247}, New Integer() {2, 1}, New Integer() {0, 127}, New Integer() {0, 143}, New Integer() {10, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 248}, New Integer() {0, 249}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 159}, New Integer() {0, 175}, New Integer() {0, 250}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 251}, New Integer() {0, 191}, New Integer() {2, 1}, New Integer() {0, 252}, New Integer() {0, 207}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 253}, New Integer() {0, 223}, New Integer() {2, 1}, New Integer() {0, 254}, New Integer() {0, 239}}
            Case 32 : Return New Integer()() {New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 8}, New Integer() {0, 4}, New Integer() {2, 1}, New Integer() {0, 1}, New Integer() {0, 2}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 10}, New Integer() {2, 1}, New Integer() {0, 3}, New Integer() {0, 6}, New Integer() {6, 1}, New Integer() {2, 1}, New Integer() {0, 9}, New Integer() {2, 1}, New Integer() {0, 5}, New Integer() {0, 7}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 14}, New Integer() {0, 13}, New Integer() {2, 1}, New Integer() {0, 15}, New Integer() {0, 11}}
            Case 33 : Return New Integer()() {New Integer() {16, 1}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 0}, New Integer() {0, 1}, New Integer() {2, 1}, New Integer() {0, 2}, New Integer() {0, 3}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 4}, New Integer() {0, 5}, New Integer() {2, 1}, New Integer() {0, 6}, New Integer() {0, 7}, New Integer() {8, 1}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 8}, New Integer() {0, 9}, New Integer() {2, 1}, New Integer() {0, 10}, New Integer() {0, 11}, New Integer() {4, 1}, New Integer() {2, 1}, New Integer() {0, 12}, New Integer() {0, 13}, New Integer() {2, 1}, New Integer() {0, 14}, New Integer() {0, 15}}
        End Select
    End Function

End Class
